       subroutine readcuts
       include 'declare.h'
       include 'common_masses.h'
       include 'common_int.h'
       include 'common_cuts.h'
     
       cutoff=1d-3
       print*,'WARNING: CUTOFF SET AT',cutoff
       ec(3:20)=0
       c1(3:20)=1
       c2(3:20)=1
       cc(3:20,3:20)=1
       gmas(3:20,3:20)=cutoff
       pi=dacos(-1.d0)
       
       c0=dcos(5.d0/180.d0*pi)
       c_g=dcos(5.d0/180.d0*pi)
       e0=10.d0
       g0=10.d0

c -- 6f cuts
c minimum lepton energy
       el=e0
c minimum quark  energy
       eq=e0
c minimum photon energy
       eg=e0
c maximum cos lepton with beam
       cl=c0
c maximum cos quark with beam
       cq=c0
c maximum cos photon with beam
       cg=c_g
c maximum cos lepton with lepton
       cll=c0
c maximum cos lepton with quark
       clq=c0
c maximum cos quark with quark
       cqq=c0
c maximum cos photon with fermions
       cgx=c_g
c minimum mass quark with quark
       gqq=g0
c --

       do i=3,n
       if(ifl(i).lt.13)then
        i1=iabs(mod(ifl(i),4))
       else
        i1=ifl(i)
       endif
        if(i1.eq.35)i1=0
       ec(i)=parmas(ifl(i))
c   photons
       if(i1.eq.31)then
        ec(i)=eg
        c1(i)=cg
        c2(i)=cg
       endif
c   neutrinos
       if(i1.eq.1)then
       endif
c   ch. leptons
       if(i1.eq.2)then
        ec(i)=max(el,ec(i))
        c1(i)=cl
        c2(i)=cl
       endif
c   quarks
       if(i1.eq.3.or.i1.eq.0)then
        ec(i)=max(eq,ec(i))
        c1(i)=cq
        c2(i)=cq
       endif
       enddo
    
       do i=3,n-1
       if(ifl(i).lt.13)then
        i1=iabs(mod(ifl(i),4))
       else
        i1=ifl(i)
       endif
        if(i1.eq.35)i1=0
        do j=i+1,n
         if(ifl(j).lt.13)then
          j1=iabs(mod(ifl(j),4))
         else
          j1=ifl(j)
         endif
         if(j1.eq.35)j1=0
c  n-n
         if(i1.eq.1.or.j1.eq.1)then
c  l-q
         elseif(i1.eq.2.and.(j1.eq.3.or.j1.eq.0))then
         cc(i,j)=clq
c  l-l
         elseif(i1.eq.2.and.j1.eq.2)then
         cc(i,j)=cll
c  q-l
         elseif(j1.eq.2.and.(i1.eq.3.or.i1.eq.0))then
         cc(i,j)=clq
c  g-x  photon-charged
         elseif(i1.eq.31.and.j1.ne.1)then
         cc(i,j)=cgx
c  x-g  charged-photon
         elseif(j1.eq.31.and.i1.ne.1)then
         cc(i,j)=cgx
c  q-q
         elseif((i1.eq.3.or.i1.eq.0).and.
     .          (j1.eq.3.or.j1.eq.0))then
         cc(i,j)=cqq
         gmas(i,j)=gqq
c
         endif
        enddo
       enddo

       do l=4,20
        do k=3,l-1
         gmas(l,k)=gmas(k,l)
           cc(l,k)=  cc(k,l)
        enddo
       enddo

       print*,'---------------------------------------------------'
       print*,'        the cuts        '
       do i=3,n
       print*,'energy of  ',i,ifl(i),'   particle   ',ec(i)
       enddo
       do i=3,n
       print*,'cos-beam1 of ',i,ifl(i),'   particle   ',c1(i)
       enddo
       do i=3,n
       print*,'cos-beam2 of ',i,ifl(i),'   particle   ',c2(i)
       enddo

       do i=3,n-1
        do j=i+1,n
         if(i.ne.j)
     .   print*,'cos of ',i,ifl(i),'  with  ',j,ifl(j),'  ',cc(i,j)
        enddo
       enddo

       do i=3,n-1
        do j=i+1,n
         if(i.ne.j)
     .   print*,'mass of ',i,ifl(i),'  with  ',j,ifl(j),'  ',gmas(i,j)
        enddo
       enddo
       print*,'---------------------------------------------------'

       return
       end
      
       subroutine cuts(icut)
       include 'declare.h'
       
       include 'common_int.h'
       include 'common_phegas_mom.h'
       include 'common_cuts.h'

       
       icut=0
       
       do l=3,n 
       if(pmom(l,4).lt.ec(l))return
       c=pmom(l,3)/pmom(l,4)
       if( c.gt.c1(l))return
       if(-c.gt.c2(l))return
       enddo
       
       do l1=3,n
        do l2=3,n
         if(l1.eq.l2)cycle
         if(cosij(pmom(l1,1:3),pmom(l2,1:3)).gt.cc(l1,l2))return
         s=2*scalar_product(pmom(l1,1:4),pmom(l2,1:4))
     .    +scalar_product(pmom(l1,1:4),pmom(l1,1:4))
     .    +scalar_product(pmom(l2,1:4),pmom(l2,1:4))
         if(s.lt.gmas(l1,l2)**2)return
        enddo
       enddo
       

c      print'(i4,4e20.13)',(i,(pmom(i,l),l=1,4),i=3,n)

       icut=1
       
       return
       end
       
       
       
