       subroutine readcuts
       include 'declare.h'
       include 'common_masses.h'
       include 'common_int.h'
       include 'common_cuts.h'
       character*24 file
     
       cutoff=1.d-3
       print*,'WARNING CUTOFF SET:',cutoff
       ptc(3:20)=cutoff
       drc(3:20,3:20)=0
       etac(3:20)=100
       ec(3:20)=1
       c1(3:20)=1
       c2(3:20)=1
       cc(3:20,3:20)=1
       gmas(3:20,3:20)=cutoff
       pi=dacos(-dnou(1))
       
c -- PP cuts
       pt0=60.0d0
       eta0=2.5d0
       dr0=1.0d0
       g0=cutoff
c minimum lepton pt
       ptl=pt0
c minimum quark  pt
       ptq=pt0
c minimum photon pt
       ptg=pt0
c maximum rapidity lepton
       etal=eta0
c maximum rapidity quark 
       etaq=eta0
c maximum rapidity photon 
       etag=eta0
c minimum DR lepton with lepton
       drll=dr0
c minimum DR lepton with quark
       drlq=dr0
c minimum DR quark with quark
       drqq=dr0
c minimum DR photon with fermion
       drgx=dr0
c minimum mass quark with quark
       gqq=g0
c --

       do i=3,n
       if(ifl(i).lt.13)then
        i1=iabs(mod(ifl(i),4))
       else
        i1=ifl(i)
       endif
        if(i1.eq.35)i1=0
        goto 111
c -------
c special for mc4lhc 2003
c[
c       if(ifl(i).eq.11)i1=-1
c       if(ifl(i).eq.-11)i1=-1
c       if(ifl(i).eq.12)i1=-1
c       if(ifl(i).eq.-12)i1=-1
c]

 111    continue
c   photons
       if(i1.eq.31)then
        ptc(i)=ptg
        etac(i)=etag
       endif
c   neutrinos
       if(i1.eq.1)then
       endif
c   ch. leptons
       if(i1.eq.2)then
c      if(i1.le.2)then
        ptc(i)=ptl
        etac(i)=etal
       endif
c   quarks
       if(i1.eq.3.or.i1.eq.0)then
        ptc(i)=ptq
        etac(i)=etaq
       endif
       enddo
    
       do i=3,n-1
       if(ifl(i).lt.13)then
        i1=iabs(mod(ifl(i),4))
       else
        i1=ifl(i)
       endif
        if(i1.eq.35)i1=0

        goto 222
c -------
c special for mc4lhc 2003
c[
c       if(ifl(i).eq.11)i1=-1
c       if(ifl(i).eq.-11)i1=-1
c       if(ifl(i).eq.12)i1=-1
c       if(ifl(i).eq.-12)i1=-1
c]

 222    continue
        do j=i+1,n
         if(ifl(j).lt.13)then
          j1=iabs(mod(ifl(j),4))
         else
          j1=ifl(j)
         endif
         if(j1.eq.35)j1=0
         goto 333

c -------
c special for mc4lhc 2003
c[
c       if(ifl(j).eq.11)j1=-1
c       if(ifl(j).eq.-11)j1=-1
c       if(ifl(j).eq.12)j1=-1
c       if(ifl(j).eq.-12)j1=-1
c]
 333    continue

c  n-n
         if(i1.eq.1.or.j1.eq.1)then
c  l-q
         elseif(i1.eq.2.and.(j1.eq.3.or.j1.eq.0))then
         drc(i,j)=drlq
c  l-l
         elseif(i1.eq.2.and.j1.eq.2)then
         drc(i,j)=drll
c  q-l
         elseif(j1.eq.2.and.(i1.eq.3.or.i1.eq.0))then
         drc(i,j)=drlq
c  g-x  photon-charged
         elseif(i1.eq.31.and.j1.ne.1)then
         drc(i,j)=drgx
c  x-g  charged-photon
         elseif(j1.eq.31.and.i1.ne.1)then
         drc(i,j)=drgx
c  q-q
         elseif((i1.eq.3.or.i1.eq.0).and.
     .          (j1.eq.3.or.j1.eq.0))then
         drc(i,j)=drqq
         gmas(i,j)=gqq
c
         endif
        enddo
       enddo
   
       do i=3,n
        ec(i)=max(ptc(i),parmas(ifl(i)))
        r=exp(2*etac(i))
        c1(i)=(r-1)/(r+1)
        c2(i)=c1(i)
       enddo 
   
       do i=3,n-1
        do j=i+1,n
c        ri=sqrt(1-c1(i)*c1(i))
c        rj=sqrt(1-c1(j)*c1(j))
c        cc(i,j)=c1(i)*c1(j)+ri*rj*cos(drc(i,j))
         cc(i,j)=cos(drc(i,j))
        enddo
       enddo

       do i=3,n-1
        do j=i+1,n
         gmas(i,j)=max(gmas(i,j),
     &             dsqrt( 2*ptc(i)*ptc(j)*(1-cos(drc(i,j))) ) )
        enddo
       enddo

       do l=4,20
        do k=3,l-1
          drc(l,k)= drc(k,l)
           cc(l,k)=  cc(k,l)
           gmas(l,k)=  gmas(k,l)
        enddo
       enddo

  
       print*,'---------------------------------------------------'
       print*,'        the cuts        '
       do i=3,n
       print*,'pt     of  ',i,'   particle   ',ptc(i)
       print*,'energy of  ',i,'   particle   ',ec(i)
       enddo
       do i=3,n
       print*,'rapidity of  ',i,'   particle   ',etac(i)
       enddo
       do i=3,n
       print*,'cos-beam1 of ',i,'   particle   ',c1(i)
       enddo
       do i=3,n
       print*,'cos-beam2 of ',i,'   particle   ',c2(i)
       enddo

       do i=3,n-1
        do j=i+1,n
         if(i.ne.j)then
         print*,'DR     ',i,'  with  ',j,drc(i,j)
         print*,'cos of ',i,'  with  ',j,cc(i,j)
         endif
        enddo
       enddo

       do i=3,n-1
        do j=i+1,n
         if(i.ne.j)
     .   print*,'mass of ',i,'  with  ',j,gmas(i,j)
        enddo
       enddo
       print*,'---------------------------------------------------'

       return
       end
      
      subroutine cuts(icut)
      include 'declare.h'
      include 'common_int.h'
      include 'common_phegas_mom.h'
      include 'common_strf.h'
      include 'common_cuts.h'
      dimension p(20,4)
      dimension pboo(4)

      pi=dacos(-dnou(1))

c     -----
c     special for mc4lhc
c     -----
      do i=3,n
         p(i,1:4)=pmom(i,1:4)
c         print*,'p(',i,',1:4) ==>',p(i,1:4)
      enddo
      icut=0
      if(istruc.eq.1)then
         q=ehat
         e=q/sqrt(xp1*xp2)
         pboo(4)=(xp1+xp2)*e/2
         pboo(3)=(xp1-xp2)*e/2
         pboo(1:2)=0
         do i=3,n
            call boostl(q,pboo,p(i,1:4))
         enddo
      endif
c     ---
c     
c     ---
      do l=3,n 
         pt=sqrt(p(l,1)**2+p(l,2)**2)
         if(pt.lt.ptc(l)) then
c            print*,'pt.lt.ptc(l)'
            goto 1000
         endif
         eta=rapidity(p(l,1:3))
         if(abs(eta).gt.etac(l)) then 
c            print*,'abs(eta).gt.etac(l)'       
            goto 1000 
         endif
c         print*,'pt,eta ==>',pt,eta
      enddo
      do l1=3,n
         do l2=3,n
            if(l1.eq.l2)cycle
            d1=rapidity(p(l1,1:3))-rapidity(p(l2,1:3))
            d2=ph4(p(l1,1),p(l1,2),p(l1,3))
     .           -ph4(p(l2,1),p(l2,2),p(l2,3))
            d2=min(dabs(d2),2*pi-dabs(d2))
            if(d2/pi.gt.1.d0)print*,d2/pi
            dr=sqrt(d1**2+d2**2)

            if(dr.lt.drc(l1,l2))  then 
               goto 1000
            endif

c            dtheta=p(l1,1)*p(l2,1)+p(l1,2)*p(l2,2)+p(l1,3)*p(l2,3)
c            dtheta=dtheta/dsqrt(p(l1,1)**2+p(l1,2)**2+p(l1,3)**2)
c            dtheta=dtheta/dsqrt(p(l2,1)**2+p(l2,2)**2+p(l2,3)**2)
c           print*,'dtheta(',l1,',',l2,')',dtheta
c            if(dabs(dtheta).gt.1.d0) stop            
c            theta=dacos(dtheta)/dacos(-1.d0)*180.d0
c           print*,'theta(',l1,',',l2,')',theta
c            if(theta.lt.30.d0)  then 
c               goto 1000
c            endif

         enddo
      enddo
      icut=1
 1000 continue
c     ---
c     boost to the cms
c     ---
      if(istruc.eq.1)then
         pboo(3)=-(xp1-xp2)*e/2
         do i=3,n
            call boostl(q,pboo,p(i,1:4))
         enddo
      endif
c     ---
c     
c     ---
      return
      end
      
