      subroutine durham(np,et,xt,p)
      implicit double precision (a-h,o-z)

      integer gamma,gamma1

      dimension p(100,4),pboo(4),pin(4)
      dimension qt(100),phi(100),y(100)

      save
      data init/0/

      common/durhamc/qt

      n=np

      if(init.eq.0)then

       cutrap=1d0
       cutpt=10d0
       pi=dacos(-1d0)
       iv=2

       gamma=1
       do i=1,n
        gamma=gamma*i
       enddo       
       gamma1=gamma/n/(n-1)

c      gamma1=1
c      do i=1,2*n-3
c       gamma1=gamma1*i
c      enddo
     
c      gamma1=n-1

c      print*,'gamma,gamma1',gamma,gamma1
      ndim=2*n-2
  
      print*,'durham0 params:   n,ndim,cutrap,cutpt,gamma1'
      print*,'durham0 params: ',n,ndim,cutrap,cutpt,gamma1
       
       init=1

      endif

      w=1
      qq=dsqrt(et**2-xt**2)

 100  continue
      
      do i=2,n
c      call adapt_gen(10,0d0,1d0,r,iv+i-1)
       r=rnmy(0)
       qt(i)=-cutpt*dlog(r)
c      x=productlog(r)
c      qt(i)=x*cutpt
      enddo

      y(1)=0
      do i=2,n
c      call adapt_gen(10,0d0,1d0,r,iv+i-1)
       r=rnmy(0)
c      y(i)=cutrap*(2*r-1) !-y(i-1)
c      w=w*cutrap*2
       f=dexp(4*cutrap*(2*r-1))
       ff=dsqrt(2*f*dcosh(4*cutrap)-1-f**2)
       ch1=(1+f)*dsinh(2*cutrap)/ff
       sh1=(f-1)*dcosh(2*cutrap)/ff
       y(i)=dlog(ch1+sh1)
       w=w*8*cutrap/( dtanh(2*cutrap-y(i))+dtanh(2*cutrap+y(i)) )
c      write(99,*)y(i)
c      y(i)=y(i)+y(i-1)
      enddo

      phi(1)=0
      do i=2,n
c      call adapt_gen(10,0d0,1d0,r,iv+i+2*n-3)
       r=rnmy(0)
       phi(i)=2*pi*r     !-phi(i-1)
       w=w*2*pi
c      phi(i)=phi(i)+phi(i-1)
      enddo

C define qt1,phi1

      qx=0
      qy=0
      do i=2,n
       qx=qx+qt(i)*dcos(phi(i))
       qy=qy+qt(i)*dsin(phi(i))
      enddo
      qt(1)=dsqrt(qx*qx+qy*qy)
      c1=-qx/qt(1)
      s1=-qy/qt(1)
      phi(1)=dacos(c1)
      if(s1.lt.0)phi(1)=2*pi-phi(1)


C define x and y1 

      e0=0
      x0=0
      do i=1,n
       e0=e0+qt(i)*dcosh(y(i))
       x0=x0+qt(i)*dsinh(y(i))
      enddo
      q0=dsqrt(e0**2-x0**2)
 
      if(q0/e0.le.0)goto 100

      xres=qq/q0

      ch1=( e0*et-x0*xt)/q0/qq
      sh1=(-x0*et+e0*xt)/q0/qq
      if(ch1+sh1.le.0)goto 100
      y(1)=dlog(ch1+sh1)

c     write(101,*)y(1),xres
 
      do i=2,n
       y(i)=y(i)+y(1)
      enddo

C define momenta
       p4=0
       p3=0
c      p2=0
c      p1=0
      do i=1,n
       p(i,1)=xres*qt(i)*dcos(phi(i))
       p(i,2)=xres*qt(i)*dsin(phi(i))
       p(i,3)=xres*qt(i)*dsinh(y(i))
       p(i,4)=xres*qt(i)*dcosh(y(i))

       p4=p4+p(i,4)
       p3=p3+p(i,3)
c      p2=p2+p(i,2)
c      p1=p1+p(i,1)
c      if(qt(i)*xres.lt.60d0)print*,'FAIL'
      enddo

         pboo(4)=p4
         pboo(3)=-p3
         pboo(1:2)=0
         do i=1,n
            pin(1:4)=p(i,1:4)
            call boostl(qq,pboo,pin)
            p(i,1:4)=pin(1:4)
         enddo


c     print*,qq,p4,p3,p2,p1
c     print*,'OUT OF'
      return

C define weight factor
      entry durham_wei(wght)

      pt=0

      do j=2,n
       w=w*xres*qt(j)
       pt=pt+xres*qt(j)
c      if(xres*qt(j).gt.pt)pt=xres*qt(j)
      enddo


      w=w/qq**2
     .   *pt**(n-1)
c    .   *pt**(2*(n-1))
     .   /2**n
     .   /gamma1

      wght=w

      return
      end
 
      function productlog(x)
      implicit double precision (a-h,o-z)

* solve 1-(1+y)Exp(-y)=x 0<x<1

c     print*,'IN',x
      y0=-dlog(1d0-x)

 1    continue
*     y=y-(1-(1+y)*dexp(-y)-x)/(y*dexp(-y))
      y1=y0-(dexp(y0)*(1-x)-(1+y0))/y0

      if(dabs(y1-y0)/y0.gt.1d-6)then
       y0=y1
       goto 1
      endif
     
      productlog=y1
c     print*,'OUT',y1

      return
      end
