      subroutine mad(w)
      include 'declare_dp.h'
      save init
      data init/0/
      if(init.eq.0)then
       call setcoup
       init=1
      endif
      call setmom
      call matrix(w)
      return
      end

      subroutine matrix(w)
      include 'declare_dp.h'
      common/madmom/p1(0:3,1:100)
      call SMADPRO(P1,ANS)
      w=ANS
      return
      end


      subroutine setmom
      include 'declare_dp.h'
      include 'common_int.h'
      include 'common_phegas_mom.h'
      common/madmom/p1(0:3,1:100)
      do i=1,n
       p1(0,i)=pmom(i,4)
       p1(1:3,i)=pmom(i,1:3)
      enddo
      return
      end
  
      
      subroutine setcoup
      implicit real(kind(1.d0)) (a-h,o-z)


      double complex  ci
      parameter( ci = ( 0.0d0, 1.0d0 ) )
      double precision  Zero, One, Two, Three, Four, Half, Rt2
      parameter( Zero = 0.0d0, One = 1.0d0, Two = 2.0d0 )
      parameter( Three = 3.0d0, Four = 4.0d0, Half = 0.5d0 )
      double precision  Pi, Fourpi
      parameter( Pi = 3.14159265358979323846d0 )
      parameter( Fourpi = Four * Pi )
      logical HELAS_CHECK
      data HELAS_CHECK/.false./


c====================================================================
c
c  Define common block containing all coupling constants and masses.
c
c====================================================================
c
      double complex       gg(2)
      double precision     alpha,ee, sin2w, gfermi, alfas,g
      common /COUPL_BASIC/ alpha,ee, sin2w, gfermi, alfas,g,gg   

      double precision     hmass, wmass, zmass, amass,
     &                     tmass, bmass, lmass, cmass
      common /COUPL_MASS/  hmass, wmass, zmass, amass,
     &                     tmass, bmass, lmass, cmass

      double precision     hwidth, wwidth, zwidth, 
     &                     twidth
      common /COUPL_WIDTH/ hwidth, wwidth, zwidth, 
     &                     twidth

      double complex       gal(2), gad(2), gau(2), gwf(2),
     &                     gzn(2), gzl(2), gzd(2), gzu(2)
      double precision     gw, gwwa, gwwz
      common /COUPL_GAUGE/ gal   , gad   , gau   , gwf   ,
     &                     gzn   , gzl   , gzd   , gzu   ,
     &                     gw, gwwa, gwwz

      double complex     gwfc(2),  gwfs(2)
      common /coupl_ckm/   gwfc,  gwfs	

      double complex       gwwh, gzzh, gwwhh, gzzhh, ghhh, ghhhh
      common /COUPL_SCAL/  gwwh, gzzh, gwwhh, gzzhh, ghhh, ghhhh

      double complex       ghtop(2), ghbot(2), ghtau(2)
      common /COUPL_YUK/   ghtop   , ghbot   , ghtau

      double precision     xzmass, xwmass
      common /COUPL_XMASS/ xzmass, xwmass

      double complex       xzl(2) , xzb(2) , xzt(2) ,
     &                     xwpq(2), xwmq(2), xwpl(2), xwml(2)
      common /COUPL_XFFV/  xzl    , xzb    , xzt    ,
     &                     xwpq   , xwmq   , xwpl   , xwml

      double complex       xzhz, xwhwp, xwhwm
      common /COUPL_XVSS/  xzhz, xwhwp, xwhwm

      double complex       xwzwp, xwzwm, xwawp, xwawm
      common /COUPL_XVVS/  xwzwp, xwzwm, xwawp, xwawm

      double complex       xwzhwp, xwzhwm, xwahwp, xwahwm
      common /COUPL_XVVSS/ xwzhwp, xwzhwm, xwahwp, xwahwm
      
      dimension parmas(-12:44),parwid(-12:44)
      logical onlyqcd,withqcd 
      data onlyqcd/.false./,withqcd/.true./

      Rt2 = dsqrt(Two)


      include 'constants.h'

      zmass=parmas(32)
      zwidth=parwid(32)
      wmass=parmas(33)
      wwidth=parwid(33)
      sin2w=rsw2
c 500: 0.0891  300: 0.0925  hep/ph0206070 0.1181
c --

       hmass=parmas(41)
       hwidth=parwid(41)
       tmass= parmas(11)
       twidth= parwid(11)
       lmass=parmas(10)
       bmass=parmas(12)
       cmass=parmas(7)


       g=gqcd
       ee2=alpha*4*pi
         
c
c useful values
c
      sw  = dsqrt( sin2w )
      cw  = dsqrt(1-sin2w)
      ee  = dsqrt( ee2 )
      ez  = ee/(sw*cw)
      ey  = ee*(sw/cw)
      sc2 = sin2w*( One - sin2w )
      v   = Two*zmass*dsqrt(sc2)/ee
      lambda = hmass**2 / (Two * v**2)

c vector boson couplings
c
      gw   = ee/sw
      gwwa = ee
      gwwz = ee*cw/sw
c
c gauge & higgs boson coupling constants
c
      gwwh  = dcmplx( ee2/sin2w*Half*v, Zero )
      gzzh  = dcmplx( ee2/sc2*Half*v, Zero )
      ghhh  = dcmplx( -hmass**2/v*Three, Zero )
      gwwhh = dcmplx( ee2/sin2w*Half, Zero )
      gzzhh = dcmplx( ee2/sc2*Half, Zero )
      ghhhh = ghhh/v
c
c fermion-fermion-vector couplings
c
      gal(1) = dcmplx(  ee          , Zero )
      gal(2) = dcmplx(  ee          , Zero )
      gau(1) = dcmplx( -ee*Two/Three, Zero )
      gau(2) = dcmplx( -ee*Two/Three, Zero )
      gad(1) = dcmplx(  ee/Three    , Zero )
      gad(2) = dcmplx(  ee/Three    , Zero )

      gwf(1) = dcmplx( -ee/dsqrt(Two*sin2w), Zero )
      gwf(2) = dcmplx(  Zero              , Zero )

      gzn(1) = dcmplx( -ez*Half                     , Zero )
      gzn(2) = dcmplx(  Zero                        , Zero )
      gzl(1) = dcmplx( -ez*(-Half + sin2w)          , Zero )
      gzl(2) = dcmplx( -ey                          , Zero )
      gzu(1) = dcmplx( -ez*( Half - sin2w*Two/Three), Zero )
      gzu(2) = dcmplx(  ey*Two/Three                , Zero )
      gzd(1) = dcmplx( -ez*(-Half + sin2w/Three)    , Zero )
      gzd(2) = dcmplx( -ey/Three                    , Zero )
c
c
c fermion-fermion-Higgs couplings (complex) hff(2)
c
      ghtop(1) = dcmplx( -tmass/v, Zero )
      ghtop(2) = ghtop(1)

      ghbot(1) = dcmplx( -bmass/v, Zero )
      ghbot(2) = ghbot(1)

      ghtau(1) = dcmplx( -lmass/v, Zero )
      ghtau(2) = ghtau(1)

c
c QCD couplings
c
      gg(1) = dcmplx( -g, Zero )
      gg(2) = gg(1)
c
c fermion-fermion-Higgs couplings (complex) hff(2)
c
      ghtop(1) = dcmplx( -tmass/v, Zero )
      ghtop(2) = ghtop(1)

      ghbot(1) = dcmplx( -bmass/v, Zero )
      ghbot(2) = ghbot(1)

      ghtau(1) = dcmplx( -lmass/v, Zero )
      ghtau(2) = ghtau(1)

c


      if(HELAS_CHECK)then
c
c   masses
c
      xzmass = zmass
      xwmass = wmass
c
c   VHS - verified
c
      xzhz  = -ci*Half*gw/cw
      xwhwp = -ci*Half*gw
      xwhwm = dconjg(xwhwp)
c
c   VVS - verified
c
      xwzwp =  ci * gw * zmass * sin2w
      xwzwm = dconjg(xwzwp)
      xwawp = -ci * ee * wmass
      xwawm = dconjg(xwawp)
c
c   VVHS - verified
c
      xwzhwp =  ci * Half * gw**2 * sin2w / cw
      xwzhwm = dconjg(xwzhwp)
      xwahwp = -ci * Half * gw * ee
      xwahwm = dconjg(xwahwp)

c
c   FFS - verified
c
      ghtop(1) = dcmplx( -tmass/v, Zero )
      ghtop(2) = ghtop(1)

      ghbot(1) = dcmplx( -bmass/v, Zero )
      ghbot(2) = ghbot(1)

      ghtau(1) = dcmplx( -lmass/v, Zero )
      ghtau(2) = ghtau(1)

      xzt(1) = -ghtop(1)*ci
      xzt(2) = dconjg(xzt(1))
      xzb(1) =  ghbot(1)*ci
      xzb(2) = dconjg(xzb(1))
      xzl(1) =  ghtau(1)*ci
      xzl(2) = dconjg(xzl(1))

      xwpq(1) =  ci*Rt2*bmass/v
      xwpq(2) = -ci*Rt2*tmass/v
      xwmq(1) = -xwpq(2)
      xwmq(2) = -xwpq(1)
      xwpl(1) =  ci*Rt2*lmass/v
      xwpl(2) = Zero
      xwml(1) = Zero
      xwml(2) = -xwpl(1)
c
c override boson widths for BRS check
c
      hwidth = Zero
      zwidth = Zero
      wwidth = Zero
      twidth = Zero
c
c output BRS check acknowledgement
c
      write(6,*) '*** HELAS COUPSM in BRS check mode ***'
      write(6,*)
      endif


c
c output all info
c
 10   format( 1x,a,f7.3,' GeV        ',a,f8.4,' GeV' )
 11   format( 1x,a,f10.7,2x,f10.7,a,f10.7,2x,f10.7 )
 12   format( 1x,a,f6.2,a )
 13   format( 1x,a,f6.4,a )
 14   format( 1x,2(a,f10.7,', ',f10.7) )
 15   format( 1x,a,f9.5,a )
 16   format( 1x,a,f7.5 )
 17   format( 1x,a,f8.4 )
 18   format( 1x,a,f8.4,' GeV' )
 19   format( 1x,a,f6.4,a,f6.4 )
 20   format( 1x,a,f11.5,1x,f11.5 )

      write(6,*) '*** HELAS Standard Model parameters ***'
      write(6,*)
      write(6,12) '1/alpha = ',One/alpha,
     &            '  from input/MS-bar relations'
      write(6,*)
      write(6,13) 'alpha_s = ',gqcd**2/4/pi,
     &            '  from input'
      write(6,*)
      write(6,13) 'sin^2(theta_W) =  ',sin2w
      write(6,*)
      write(6,10) 'Z mass  =  ',zmass, 'Z width  = ',zwidth
      write(6,10) 'W mass  =  ',wmass, 'W width  = ',wwidth
      write(6,10) 'H mass  =  ',hmass, 'H width  = ',hwidth
      write(6,*)
      write(6,10) 'top    mass  =  ', tmass, 'top    width  = ', twidth
      write(6,10) 'bottom mass  =  ', bmass, 'bottom width  = ', Zero
      write(6,10) 'charm  mass  =  ', cmass, 'charm  width  = ', Zero
      write(6,10) 'tau    mass  =  ', lmass, 'tau    width  = ', Zero
      write(6,*) 'all other quark and lepton masses set to zero'
      write(6,*)
      write(6,*) 'Boson couplings:'
      write(6,*)
      write(6,*) 'gw    = ', gw, '  from input/MS-bar relations'
      write(6,*)
      write(6,20) 'gwwa  = ', gwwa
      write(6,20) 'gwwz  = ', gwwz
      write(6,20) 'gwwh  = ', gwwh
      write(6,20) 'gzzh  = ', gzzh
      write(6,20) 'ghhh  = ', ghhh
      write(6,*)
      write(6,20) 'gwwhh = ', gwwhh
      write(6,20) 'gzzhh = ', gzzhh
      write(6,20) 'ghhhh = ', ghhhh
      write(6,*)
      write(6,*) 'FFV couplings:'
      write(6,*)
      write(6,11) 'ggq(L)   =  ',gg(1),  '    ggq(R)   =  ',gg(2)
      write(6,*)
      write(6,11) 'gal(L)   =  ',gal(1), '    gal(R)   =  ',gal(2)
      write(6,11) 'gau(L)   =  ',gau(1), '    gau(R)   =  ',gau(2)
      write(6,11) 'gad(L)   =  ',gad(1), '    gad(R)   =  ',gad(2)
      write(6,*)
      write(6,11) 'gwf(L)   =  ',gwf(1), '    gwf(R)   =  ',gwf(2)
      write(6,*)
      write(6,11) 'gzn(L)   =  ',gzn(1), '    gzn(R)   =  ',gzn(2)
      write(6,11) 'gzl(L)   =  ',gzl(1), '    gzl(R)   =  ',gzl(2)
      write(6,11) 'gzu(L)   =  ',gzu(1), '    gzu(R)   =  ',gzu(2)
      write(6,11) 'gzd(L)   =  ',gzd(1), '    gzd(R)   =  ',gzd(2)
      write(6,*)
      write(6,*) 'FFH couplings:'
      write(6,*)
      write(6,14) 'gHtop(L) =  ',ghtop(1), '    gHtop(R) =  ',ghtop(2)
      write(6,14) 'gHbot(L) =  ',ghbot(1), '    gHbot(R) =  ',ghbot(2)
      write(6,14) 'gHtau(L) =  ',ghtau(1), '    gHtau(R) =  ',ghtau(2)
      write(6,*)
      write(6,*)
      if(HELAS_CHECK)then
      write(6,*) 'BRS couplings:'
      write(6,*)
      write(6,10) 'xz mass =  ',zmass
      write(6,10) 'xw mass =  ',wmass
      write(6,*)
      write(6,20) 'VHS  ZHxz   = ',xzhz
      write(6,20) 'VHS  WHxwp  = ',xwhwp
      write(6,20) 'VHS  WHxwm  = ',xwhwm
      write(6,*)
      write(6,20) 'VVS  WZxwp  = ',xwzwp
      write(6,20) 'VVS  WZxwm  = ',xwzwm
      write(6,20) 'VVS  WAxwp  = ',xwawp
      write(6,20) 'VVS  WAxwm  = ',xwawm
      write(6,*)
      write(6,20) 'VVHS WZHxwp = ',xwzwp
      write(6,20) 'VVHS WZHxwm = ',xwzwm
      write(6,20) 'VVHS WAHxwp = ',xwawp
      write(6,20) 'VVHS WAHxwm = ',xwawm
      write(6,*)
      write(6,14) 'xztop(L) =  ',xzt(1), '    xztop(R) =  ',xzt(2)
      write(6,14) 'xzbot(L) =  ',xzb(1), '    xzbot(R) =  ',xzb(2)
      write(6,14) 'xztau(L) =  ',xzl(1), '    xztau(R) =  ',xzl(2)
      write(6,*)
      write(6,14) 'xwpq(L)  =  ',xwpq(1), '    xwpq(R)  =  ',xwpq(2)
      write(6,14) 'xwmq(L)  =  ',xwmq(1), '    xwpm(R)  =  ',xwmq(2)
      write(6,14) 'xwpl(L)  =  ',xwpl(1), '    xwpl(R)  =  ',xwpl(2)
      write(6,14) 'xwml(L)  =  ',xwml(1), '    xwml(R)  =  ',xwml(2)
      write(6,*)
      endif
ccc
c     stop
      return
      end

       
      subroutine switchmom(p1,p,ic,jc,nexternal)
c**************************************************************************
c     Changes stuff for crossings
c**************************************************************************
      implicit none
      integer nexternal
      integer jc(nexternal),ic(nexternal)
      real*8 p1(0:3,nexternal),p(0:3,nexternal)
      integer i,j
c-----
c Begin Code
c-----
      do i=1,nexternal
         do j=0,3
            p(j,ic(i))=p1(j,i)
         enddo
      enddo
      do i=1,nexternal
         jc(i)=1
      enddo
      jc(ic(1))=-1
      jc(ic(2))=-1
      end


