C       
C       
C       
C      commons to be set by the user
C
C      common/helac_int/n,io(20),ifl(20)
C      
C      common/helac_mom/zq(20,5)
C        n:               number of particles involved
C        zq(1:n,1:5):     momentum 1->  (p0+pz , pz)  
C                                  2->  (p0-pz , pt), pt=sqrt(px^2+py^2)
C                                  3->  (px    , py)
C                                  4->  (px    ,-py)
C                                  5->  (m     , p ), p=sqrt(px^2+py^2+pz^2)
C        ifl(1:n):        flavour
C        io(1:n):         =1 incoming =-1 outgoing
C      common/helac_flags/iflag,iunitary,ihiggs
C        iflag:           0 sum over all helicities, 1 give helicity confg.
C        iunitary:        1 unitary gauge, 0 Feynman gauge
C        ihiggs:          0 no higgs, 1 higgs is included
C      common/helac_masses/parmas(-12:44),parwid(-12:44)
C        parmass:          masses of known particles
C        parwid:           widths of known particles
C       
C       
C    FOR COMPLEX-WIDTH SCHEME 
C    complex mass definition appears in compl_mass.h
C       
C       
C       
C       
**********************************************************
*					                 *
*    The correspondence table for particles              *
*					                 *
*					                 *
*					                 *
*      n,e,u,d,n,m,c,s,...  1,.., 12                     *
* anti-n,e,u,d,n,m,c,s,... -1,..,-12                     *
*      A,Z,W+,W-,...        31,..,34                     *
*      H,f0,f+,f-,...       41,..,44                     *
*					                 *
*					                 *
**********************************************************
C       
C      In the begining ---> call physics
C       
C       
C       
       subroutine helac_init
       include 'declare.h'
      
       include 'common_int.h'
       include 'common_flags.h'
       include 'common_helc.h'
       include 'common_feyn.h'
       include 'common_print.h'
       include 'common_new.h'
       include 'common_unweight.h'
       include 'common_unw.h'

      
       integer iquark(20)
             
       integer iperm(:,:)
       dimension rmatrix(:,:)
       dimension zamp(:)
       integer jcol(:,:,:)       
 
      allocatable iperm,rmatrix,zamp,jcol
       save rmatrix,zamp,jcol

c      save ncc,avhel,avcol,symet,init,init_col
       save init,init_col
       save iv1,iv2

       save imc
       data imc/0/
       
       data ic1/0/
       data iquark/20*0/
       data init/0/,init_col/0/
       data init_unw/0/
    
       logical lwri

**********************************************************
*     ipol(k)=helicity,ipol(k)=2:rigth-handed            *
*                      ipol(k)=1:left-handed             *
*                      ipol(k)=3:long.                   *
**********************************************************
**********************************************************
C      start of initialization phase      
**********************************************************
       call average(avhel,avcol,symet)
       
       write(nunit1,*)'avhel,avcol,symet'
       write(nunit1,*) avhel,avcol,symet
c      call fmprnt(avhel)
c      call fmprnt(avcol)
c      call fmprnt(symet)
      
       
       iv1=31
       iv2=34
      
       call setncc(nq)
       
       ncc=ifactorial(nq)
      
       allocate(iperm(ncc,nq),stat=istat)
       allocate(jcol(ncc,n,0:2),stat=istat)

       if(istat.ne.0)print*,istat,
     & 'warning: allocation is not working properly in master'
       
       write(nunit1,*)'number of colour configurations',ncc
       call pan(ncc)
              
       if(ncc.gt.1)iv2=35
       
       do icc=1,ncc
                    
       if(nq.ne.0.and.icc.le.ncc)then
        
        if(nq.gt.1)call permu(iquark,nq)
        if(nq.eq.1)iquark(1)=1

        call setcc(iquark)


c       print*,'CHECK',nq,iquark(1:nq)
        call checkgluons(iquark,nq,icheck)
c       print*,'CHECK',icheck
        if(icheck.eq.0)cycle
        
       endif

c       print*,(i,'(',icol(i,1:2),')',i=1,n)
       write(nunit1,*)'the colour of particles ONE',(icol(i,1),i=1,n)
       write(nunit1,*)'the colour of particles TWO',(icol(i,2),i=1,n)

       call pan_ini
      
       do l=2,n-1
       
       ix1=0
       do while(ix1.eq.0)
       
       call id(n,l,ix1,i0)
c      print*,n,l,ix1,i0
       if(ix1.eq.1)goto800
      

       if(mod(i0,2).eq.0)then
       
       ix2=0
       do while(ix2.eq.0)
       
       call id2(n,l,i0,ix2,i1,i2)
c      print*,n,l,i0,ix2,i1,i2
       if(ix2.eq.1)goto801
       
       i3=0
       
       do if1=iv1,iv2
       
       call v3(i0,l,if1,i1,i2,i3)
       
       call vff(i0,l,if1,i1,i2,i3)
       
       call vvs(i0,l,if1,i1,i2,i3)
       
       call vss(i0,l,if1,i1,i2,i3)
       
       enddo
       
       do if1=41,44
      
       call svv(i0,l,if1,i1,i2,i3)
       
       call ssv(i0,l,if1,i1,i2,i3)

       call sff(i0,l,if1,i1,i2,i3)

       call s3(i0,l,if1,i1,i2,i3)
       
       enddo
       
       
       do if1=1,12
       
              
       call  ffv(i0,l, if1,i1,i2,i3)
   
       call  ffs(i0,l, if1,i1,i2,i3)
       
       call affv(i0,l,-if1,i1,i2,i3)

       call affs(i0,l,-if1,i1,i2,i3)
       
       enddo
       
 801   enddo
       
       if(l.lt.3)goto800
       ix3=0
       do while(ix3.eq.0)
       
       call id3(n,l,i0,ix3,i1,i2,i3)
c      print*,n,l,i0,ix3,i1,i2,i3
       if(ix3.eq.1)goto802
      
       do if1=iv1,iv2
       
c      print*,'NO V4 INTERACTIONS <<<<<<<<<<<<<<<<<<<<<<<'
       call v4(i0,l,if1,i1,i2,i3)
       
       call vvss(i0,l,if1,i1,i2,i3)
       
       enddo
       
      do if1=41,44
      
      call s4(i0,l,if1,i1,i2,i3)
     
      call ssvv(i0,l,if1,i1,i2,i3)
      
      enddo
       
 802   enddo
       
       endif
       
 800   enddo
       enddo

       
       call redo(ic1,ino)
       
       if(nq.ne.0.and.icc.le.ncc.and.ino.eq.0)then
        iperm(ic1,1:nq)=iquark(1:nq)

        jcol(ic1,1:n,1:2)=icol(1:n,1:2)
        jcol(ic1,1,0)=1
c        print*,ic1
c        print*,icol(1:n,1)
c        print*,icol(1:n,2)
        do i=1,n
           if(ifl(i).eq.35.and.icol(i,1).eq.icol(i,2))then
              jcol(ic1,1,0)=0
              goto 100
           endif
        enddo
 100    continue
c        print*,jcol(ic1,1,0)
        
       endif
      enddo                     !icc
       

       write(nunit1,*)'colour',ic1,ncc !-1,ncc
       ncc=ic1!-1
       
       call setlist(ncc)
       
       allocate(
     .  zamp(ncc)
     . ,rmatrix(ncc,ncc)
     . ,stat=istat)
       if(istat.ne.0)print*,istat,
     & 'warning: allocation is not working properly in master2'
     
       
       do k1=1,ncc
        do k2=k1,ncc
ccall countzeros(nq,iperm(k1,1:nq)-iperm(k2,1:nq),izeros)
         call eat(nq,iperm(k1,1:nq),iperm(k2,1:nq),izeros)
           rmatrix(k1,k2)=dnou(3)**izeros
c        if(izeros.eq.nq)then
c          rmatrix(k1,k2)=dnou(3)**nq
c        else
c          rmatrix(k1,k2)=dnou(3)**(izeros+1)
c        endif
           if(k2.gt.k1)rmatrix(k2,k1)=rmatrix(k1,k2)
        enddo
       enddo
       
       
       write(nunit1,*)'ncc,ic1',ncc,ic1
c      do k1=1,ic1
c       print'(100f5.2)',(rmatrix(k1,k2),k2=1,ic1) 
c      enddo
**********************************************************
C      end of initialization phase      
**********************************************************
       print*,'the number of colour configurations',ncc
c       stop
       print*,'the colour summation flag: imc',imc
       if(ncc.le.24)then
       write(nunit1,*)'the colour matrix'
       do i=1,ncc
       write(nunit1,'(24f8.2)')(rmatrix(i,j),j=1,ncc)
       enddo
       endif
       
       if(repeat.eq.1)then
       write(21,*)ng
       do ii=1,ng
       do jj=1,8
       write(21,*)(is(ii,jj,kk),kk=1,8)
       enddo
       enddo
       write(21,*)avhel,avcol,symet
       write(21,*)rmatrix
        do k=1,ncc
        write(21,*)jcol(k,1:n,0:2)
        enddo
       endif
       
       return
       
      entry helac_master(smel2)

      if(init.eq.0) print*,'NCC=',ncc

      if(init.eq.0.and.repeat.eq.2)then
       allocate(
     .  zamp(ncc)
     . ,rmatrix(ncc,ncc)
     . ,jcol(ncc,n,0:2)  
     . ,stat=istat)
       if(istat.ne.0)print*,istat,
     & 'warning: allocation is not working properly in master3'
       read(21,*)avhel,avcol,symet
       read(21,*)rmatrix
        do k=1,ncc
           read(21,*)jcol(k,1:n,0:2)
        enddo
c       print*,avhel,avcol,symet
c       print*,rmatrix
      endif

      smel2=dnou(0)
      
      ihel=0
      istop=0
  

      do while(istop.eq.0)
      

      if(iranhel.eq.0)then
      inegl=0
      call sethel(iflag,istop,ihel,inegl)
      inegl=1
c----
c      ipol(1:n)=1
c      istop=1

      else
      istop=1
      endif

      
      
      call iniqq
c      print*,'imc',imc 
      if(imc.eq.0)then


       do k=1,ncc
          call nextq(k)
          call ampq(k,zamp(k))
       enddo

        w1=dnou(0)
        do k1=1,ncc
         do k2=k1,ncc
          if(k2.eq.k1)
     .    w1=w1+dreal( zamp(k1)*dconjg(zamp(k2) ))*rmatrix(k1,k2) 
          if(k2.gt.k1)
     .    w1=w1+2*dreal( zamp(k1)*dconjg(zamp(k2) ))*rmatrix(k1,k2) 
         enddo
        enddo

      else

       k_1=int(rnmy(0)*ncc)+1
       k_2=int(rnmy(0)*ncc)+1

       call nextq(k_1)
       call ampq(k_1,zamp(k_1))
       call nextq(k_2)
       call ampq(k_2,zamp(k_2))

       w1=dnou(0)
       w1=dreal( zamp(k_1)*dconjg(zamp(k_2) ))*rmatrix(k_1,k_2)
       w1=w1*ncc*ncc
        

       endif

c unweight over color

c      if(lwri) then
       beta0=0
       k_un=1
       r=rnmy(0)
       wnc=0
       do k=1,ncc
        if(jcol(k,1,0).eq.1)wnc=wnc+dreal( zamp(k)*dconjg(zamp(k) )) 
       enddo
       do k=1,ncc
        alpha=dreal( zamp(k)*dconjg(zamp(k) ))/wnc
        if(jcol(k,1,0).eq.0)alpha=0
        beta1=beta0+alpha
        if(r.gt.beta0.and.r.lt.beta1)then
         k_un=k
         go to 1
        endif
        beta0=beta1
       enddo

 1     icol_un(1:n,1:2)=jcol(k_un,1:n,1:2)
c      print*,k_un
c      print*,icol_un(1:n,1)
c      print*,icol_un(1:n,2)
c      endif


       smel2=smel2+w1
      
       if(w1.eq.dnou(0))inegl=2
       if(init.eq.0.and.iranhel.eq.0)call sethel(iflag,istop,ihel,inegl)
       
       
       if(init.eq.0.and.iranhel.eq.0)then
        write(nunit1,*)(ipol(i),i=1,n)
        write(nunit1,*)w1
c       call fmprnt(w1)
       endif

      enddo


*     end of polariazation sum if any
      if(init.eq.0)print*,'HELICITY CFGS',nhc
*     *****************************************************

      smel2=smel2*avhel*avcol*symet

*     *****************************************************
      
      init=init+1 
c     print*,w1
c     if(init.eq.10)stop

      return
      end
       
        
      subroutine clean(iflag,zamp,n)
      include 'declare.h'
      
      dimension iflag(n)
      dimension zamp(n)
      
      do k=2,n
      
       do l=1,k-1
       
        if(zamp(l).eq.zamp(k))iflag(k)=l
        if(zamp(l).eq.-zamp(k))iflag(k)=-l
c    .     zamp(l).eq.-zamp(k))then
c        iflag(k)=l
c       endif
        
       enddo
       
      enddo
      
      return
      end
      
      subroutine checkgluons(iq,nq,icheck)
      include 'declare.h'
      include 'common_int.h'
      integer iq(nq)
      save igo,init
      data init/0/,igo/1/
      
      icheck=1
      if(igo.eq.0)return
      if(init.eq.0)then
       igo=0
       init=1
       do i=1,n
        if(ifl(i).ne.35)return
       enddo
       igo=1
      endif

      icheck=0
      i=1
      do ix=1,nq-2
       i=iq(i)
       if(iq(i).eq.1)return
      enddo
      icheck=1

      return
      end
