       subroutine phegas(weight,ig,idir,iweight)
       include 'declare.h'
       
       include 'common_int.h'
       include 'common_mom.h'
       include 'common_masses.h'
       include 'common_feyn.h'
       include 'common_print.h'
       include 'common_phegas_mom.h'
       include 'common_norm.h'
       include 'common_strf.h'
       include 'common_warn.h'
       common/phegas1/q,q2,e2,em
c for strf use
       character*20 parm(20)
       double precision val(20)
       
       integer y1(n),y2(n),y3(n)

       
       dimension p2(4),pboo(4),xm(20),pr(4,20)
       dimension p(:,:),cmas(:),tm(:)
       allocatable p,cmas,tm
       save p,pi,e,cmas,tm,xm,pr
       
       data init/0/
       save init,ig0
       
       r_0=0
       r_1=1
       
       weight=1
       iweight=1
       if(idir.eq.0)ig0=ig
       
       if(init.eq.0)then
c      open(100,file='messages.data')

       parmas(0)=0
       parwid(0)=-1

       iwarning(1:25)=0
       iwonders(1:25)=0
       
c ------------------------------------------------------------
       if(ng.lt.100.and.ng.gt.0)then
       do i=1,ng
        k=1
        write(nunit1,*)'the graph',i
        do while(is(i,k,1).ne.0)
         write(nunit1,*)is(i,k,1:8)
         k=k+1
         enddo 
       enddo
       endif
c ------------------------------------------------------------

       
       gevnb=dnou(38937966)/100
       call mypi(pi)
       print*,'gevnb=',gevnb
       print*,'pi=',pi
       
c  ---- setup incoming momenta
      
       allocate(
     .  p(0:2**n-2,4)
     . ,cmas(0:2**n-2)
     . ,tm(0:2**n-2)
     . ,stat=istat)
       if(istat.ne.0)print*,'warning: in phegas entry',istat
      
       cmas(0:2**n-2)=0
       tm(0:2**n-2)=0
      
       print*,'energy = ?'
       read*,e
       print*,'energy = ',e
       print*,'struc f ?'
       read*,istruc
       print*,'istruc = ',istruc
      
       p(0:2**n-2,1:4)=0
       p(1,4)=(e**2+parmas(ifl(1))**2-parmas(ifl(2))**2)/e/2
       p(1,3)=p(1,4)*dsqrt( 1-(parmas(ifl(1))/p(1,4))**2 )
       p(1,2)=0
       p(1,1)=0
       p(2,4)=(e**2+parmas(ifl(2))**2-parmas(ifl(1))**2)/e/2
       p(2,3)=-p(2,4)*dsqrt( 1-(parmas(ifl(2))/p(2,4))**2 )
       p(2,2)=0
       p(2,1)=0
       do i=1,2
       	j=2**(i-1)
       	pt=dsqrt(p(j,1)**2+p(j,2)**2)
       	pq=dsqrt(pt**2+p(j,3)**2)
       	zq(i,1)= dcmplx(p(j,4)+p(j,3),p(j,3))
       	zq(i,2)= dcmplx(p(j,4)-p(j,3),pt)
       	zq(i,3)= dcmplx(p(j,1), p(j,2))
       	zq(i,4)= dcmplx(p(j,1),-p(j,2))
       	zq(i,5)= dcmplx( parmas(ifl(i)) , pq )
       	pmom(i,1:4)=p(j,1:4)
       	pmom(i,5)=parmas(ifl(i))
       enddo  
       
       wrest=4*dsqrt( scalar_product(p(1,1:4),p(2,1:4))**2
     .                -parmas(ifl(1))**2*parmas(ifl(2))**2   )
       wrest=gevnb/wrest

       
       call readcuts
       call setmin(cmas(1:2**n-2))
       call setmax(tm(1:2**n-2),cmas(1:2**n-2))
       do i=1,2**n-2
        if(cmas(i).ne.0)write(nunit2,*)'cmas',i,cmas(i) 
       enddo
       do i=1,2**n-2
        if(tm(i).ne.0)write(nunit2,*)'tmas',i,tm(i) 
       enddo

c  --- 
c  define minimum energy
c  ---
       if(istruc.eq.1)then
        include 'phegasstrf.h'
        include 'qcdscale.h'
        tau0=(cmas(2**n-4)/e)**2
c print*,'tau0 = ',tau0,cmas(2**n-4)
       endif
c  --- 
       init=1
       endif
       
c -----
c  structure functions
c -----

       if(istruc.eq.1.and.idir.eq.0)then      !start STRF
       
       r1=rnmy(0)
       r2=rnmy(0)

       xp1=tau0**(r1*r2)
       xp2=tau0**(r1*(1.d0-r2))
       wjac=r1*dlog(tau0)**2
       ehat=sqrt(xp1*xp2)*e
       include 'qcdscale.h'

c -----

       he=dsqrt(xp1*xp2)*e
       p(1,4)=
     . (he**2+parmas(ifl(1))**2-parmas(ifl(2))**2)/he/2
       p(1,3)=p(1,4)*dsqrt( 1-(parmas(ifl(1))/p(1,4))**2 )
       p(1,2)=0
       p(1,1)=0
       p(2,4)=
     . (he**2+parmas(ifl(2))**2-parmas(ifl(1))**2)/he/2
       p(2,3)=-p(2,4)*dsqrt( 1-(parmas(ifl(2))/p(2,4))**2 )
       p(2,2)=0
       p(2,1)=0
       do i=1,2
        j=2**(i-1)
        pt=dsqrt(p(j,1)**2+p(j,2)**2)
        pq=dsqrt(pt**2+p(j,3)**2)
        zq(i,1)= dcmplx(p(j,4)+p(j,3),p(j,3))
        zq(i,2)= dcmplx(p(j,4)-p(j,3),pt)
        zq(i,3)= dcmplx(p(j,1), p(j,2))
        zq(i,4)= dcmplx(p(j,1),-p(j,2))
        zq(i,5)= dcmplx( parmas(ifl(i)) , pq )
        pmom(i,1:4)=p(j,1:4)
        pmom(i,5)=parmas(ifl(i))
       enddo
       
       call setmax(tm(1:2**n-2),cmas(1:2**n-2))
c      do i=1,2**n-2
c       if(tm(i).ne.0)print*,'tmas',i,tm(i) 
c      enddo

c -----
       endif                             !end the STRF
c -----

       p(2**n-2,1:4)=p(1,1:4)

c  ---- choose a graph  : ig

         if(ig.eq.0)then

         if(istruc.eq.1)eram=he
         if(istruc.eq.0)eram=e

         do i=3,n
          xm(i-2)=parmas(ifl(i))
         enddo

         call rambo(n-2,eram,xm,pr,wtps)

         if(idir.eq.0)then

         do i=3,n
	  j=2**(i-1)
	  p(j,1:4)=pr(1:4,i-2)
         enddo

         do i=3,n
          j=i-2
          pt=dsqrt(pr(1,j)**2+pr(2,j)**2)
          pq=dsqrt(pt**2+pr(3,j)**2)
          zq(i,1)= dcmplx(pr(4,j)+pr(3,j),pr(3,j))
          zq(i,2)= dcmplx(pr(4,j)-pr(3,j),pt) 
          zq(i,3)= dcmplx(pr(1,j), pr(2,j))
          zq(i,4)= dcmplx(pr(1,j),-pr(2,j))
          zq(i,5)= dcmplx( parmas(ifl(i)) , pq )
          pmom(i,1:4)=pr(1:4,j)
          pmom(i,5)=parmas(ifl(i))
         enddo  
	 endif
         weight=wtps*(2*pi)**(4-3*(n-2))
c        call testmom
	 return

        endif
	 
       
c  ---- when idir=1 

       if(idir.eq.1)then
       i=n-1
       i0=0
       do while(i0.eq.0)
        i=i-1
        i0=is(ig,i,1)
       enddo
       k0=i
       endif
       
c  ---- start flying over the graph

       
       if(idir.eq.0)k=1
       if(idir.eq.1)k=k0
       
 10    continue
       
       if(k.eq.0)return
 
       i0=is(ig,k,1)
       m0=is(ig,k,2)
       i1=is(ig,k,3)
       m1=is(ig,k,4)
       i2=is(ig,k,5)
       m2=is(ig,k,6)
       i3=is(ig,k,7)
       m3=is(ig,k,8)
      
c     if(ig.eq.9.and.idir.eq.0)
c     print'(a9,10i4)','in phegas',ig,k,i0,m0,i1,m1,i2,m2,i3,m3
c     print*,weight
    
       
       
       if(i0.eq.0)goto1000
      
       
       
       if(i3.eq.0.and.i1.eq.2)then
       if(idir.eq.0)then
        k=k+1
        p(i2,1:4)=p(i0,1:4)+p(2,1:4)
       endif
       if(idir.eq.1)then
        k=k-1
        p(i0,1:4)=p(i2,1:4)-p(2,1:4)
       endif
       goto10
       elseif(i3.eq.0.and.i2.eq.2)then
       if(idir.eq.0)then
        k=k+1
        p(i1,1:4)=p(i0,1:4)+p(2,1:4)
       endif
       if(idir.eq.1)then
        k=k-1
        p(i0,1:4)=p(i1,1:4)-p(2,1:4)
       endif
       goto10
       endif
       
 11    continue
 
       
       
       call bin(n,i1,y1)
       call bin(n,i2,y2)
       if(i3.ne.0)call bin(n,i3,y3)
       
       j1=0
       j2=0
       j3=0
       mm10=0
       
c LOOK IF IN THE SUBSEQUENT DECAY THERE IS A 
c SINGLE PARTICLE AND TAKE ITS FLAVOUR
c    --------
c       |
c       |
c 2  ---O----
c
       if(y1(n-1).eq.1)then
        j1=1
        call look(is(ig,1:8,1:8),k,i1,mm10)
       endif
       if(y2(n-1).eq.1)then
        j2=1
        call look(is(ig,1:8,1:8),k,i2,mm10)
        endif
       if(i3.ne.0)then
        if(y3(n-1).eq.1)then
        j3=1
        call look(is(ig,1:8,1:8),k,i3,mm10)
        endif
       endif
       
       
       if(j1.eq.0.and.j2.eq.0.and.j3.eq.0)then
        
c  ---- call s1-s2 phase space 

       
       if(idir.eq.1)then
        p(i0,1:4)=p(i1,1:4)+p(i2,1:4)
        if(i3.ne.0)p(i0,1:4)=p(i0,1:4)+p(i3,1:4)
       endif
       
       
       q1min=cmas(i1)
       q2min=cmas(i2)
       q3min=cmas(i3)
       
       
       q=scalar_product(p(i0,1:4),p(i0,1:4))
       if(q-(q1min+q2min+q3min)**2.le.0)then
c ---------------------------------------------------------------
	write(nunit2,*)
     .'----------------------------------------------------'
        write(nunit2,*)
     .'warning: 1',q,q1min,q2min,q3min,idir,ig,k,i0,i1,i2,i3
c ---------------------------------------------------------------
        if(idir.eq.0)iwarning(1)=iwarning(1)+1
        if(idir.eq.1)iwonders(1)=iwonders(1)+1
        iweight=0
        return
       endif
c ---------------------------------------------------------------
       q=dsqrt(q)
       
c ---- generate q1
       
       q1max=q-q2min-q3min
       if(level(n,i1).eq.1)q1max=q1min
       if(q1max.gt.q1min)then
        if(idir.eq.1)then
         q1=scalar_product(p(i1,1:4),p(i1,1:4))
        endif
        call gen(idir,q1min,q1max,parmas(m1),parwid(m1),q1,w1)
        w1=w1/(2*pi)
        q1=dsqrt(q1)
       else
        q1=q1min
        w1=1
       endif
       
c ---- generate q2

       q2max=q-q1-q3min
       if(level(n,i2).eq.1)q2max=q2min
       if(q2max.gt.q2min)then
        if(idir.eq.1)then
         q2=scalar_product(p(i2,1:4),p(i2,1:4)) 
        endif
        call gen(idir,q2min,q2max,parmas(m2),parwid(m2),q2,w2)
        w2=w2/(2*pi)
        q2=dsqrt(q2)
       else
        q2=q2min
        w2=1
       endif
       

c ---- generate q3

       if(i3.ne.0)then
        q3max=q-q2-q1
        if(level(n,i3).eq.1)q3max=q3min
        if(q3max.gt.q3min)then
         if(idir.eq.1)then
          q3=scalar_product(p(i3,1:4),p(i3,1:4)) 
         endif
         call gen(idir,q3min,q3max,parmas(m3),parwid(m3),q3,w3)
         w3=w3/(2*pi)
         q3=dsqrt(q3)
        else
         q3=q3min
         w3=1
        endif
       else
        w3=1
       endif
       
c ---- generate p(i1),p(i2),p(i3)

       if(i3.eq.0)then
       call twobody(idir,q,q1,q2,p(i1,1:4),p(i2,1:4),w)
       elseif(i3.ne.0)then
        if(idir.eq.1)then
         p(i2+i3,1:4)=p(i2,1:4)+p(i3,1:4)
         q23= scalar_product(p(i2+i3,1:4),p(i2+i3,1:4)) 
	 if(q23-(q2+q3)**2.lt.0)then
c ---------------------------------------------------------------
	  write(nunit2,*)
     .'----------------------------------------------------'
          write(nunit2,*)
     .'warning: 2',q23,q2,q3,k,i0,i1,i2,i3
c ---------------------------------------------------------------
          if(idir.eq.0)iwarning(2)=iwarning(2)+1
          if(idir.eq.1)iwonders(2)=iwonders(2)+1
          iweight=0
          return
         endif
c ---------------------------------------------------------------
       endif
       call threebody(idir,q,q1,q2,q3,q23,p(i1,1:4)
     .                ,p(i2,1:4),p(i3,1:4),w)
       endif
       
       
c ---- boost to the over all frame

       weight=weight*w1*w2*w3*w
       
       if(idir.eq.1)then
        k=k-1
        goto10
       endif
      
       pboo(1:4)=p(i0,1:4)
       pq=dsqrt( scalar_product(pboo,pboo) )
       call boostl(pq,pboo,p(i1,1:4))
       call boostl(pq,pboo,p(i2,1:4))
       if(i3.ne.0)call boostl(pq,pboo,p(i3,1:4))
       
       


       k=k+1
       goto10      
       
c------------------------------------------------------------------------------
c------------------------------------------------------------------------------       
       else
c------------------------------------------------------------------------------       
c------------------------------------------------------------------------------
c ---- call t1-s2 phase space  

       w_t1=1
       w_phi=1
       w_q1=1
       w_q2=1
      
c ----------------------------------------------------------
c CHECK IF THERE ARE >3 PARTICLES IN THE VERTEX 
c AND COMBINE THEM       
       itogo=0
       iq2max=0
       if(j1.eq.1)then
c       call bin(n,i1-2,y1)
c       call bin(n,i2+i3,y2)
        mm1=m1
        mm2=m2
        if(i3.gt.0)mm2=0
        ii1=i1
        ii2=i2+i3
        if(idir.eq.1)p(ii2,1:4)=p(i2,1:4)+p(i3,1:4)
        if(level(n,i1-2).eq.1)itogo=1
        if(level(n,i2+i3).eq.1)iq2max=1
       elseif(j2.eq.1)then
c       call bin(n,i2-2,y1)
c       call bin(n,i1+i3,y2)
        mm1=m2
        mm2=m1
        if(i3.gt.0)mm2=0
        ii1=i2
        ii2=i1+i3
        if(idir.eq.1)p(ii2,1:4)=p(i1,1:4)+p(i3,1:4)
        if(level(n,i2-2).eq.1)itogo=1
        if(level(n,i1+i3).eq.1)iq2max=1
       elseif(j3.eq.1)then
c       call bin(n,i3-2,y1)
c       call bin(n,i1+i2,y2)
        mm1=m3
        mm2=0
        ii1=i3
        ii2=i1+i2
        if(idir.eq.1)p(ii2,1:4)=p(i1,1:4)+p(i2,1:4)
        if(level(n,i3-2).eq.1)itogo=1
        if(level(n,i1+i2).eq.1)iq2max=1
       endif
       
c ----------------------------------------------------------
c CHECK IF THE II1 PARTICLE IS JUST 2 THEN NO GENERATION 
c IS NEDDED
c            |
c        i0  | /<---- ii2 --*
c            |/             | 
c    2 ------*----    <-----*
c
       if(ii1-2.eq.0)then
        if(idir.eq.0)p(ii2,1:4)=p(i0,1:4)+p(2,1:4)
        if(idir.eq.1)p(i0,1:4)=p(ii2,1:4)-p(2,1:4)
        if(j1.eq.1)then
         i1=i2
         m1=m2
         i2=i3
         m2=m3
        elseif(j2.eq.1)then
         i1=i1
         i2=i3
         m2=m3
        elseif(j3.eq.1)then
         i1=i1
         i2=i2
        endif
        i3=0
        m3=0
        i0=ii2
        goto11
       endif
       
       q1min=cmas(ii1-2)
       q2min=cmas(ii2)
       
       if(idir.eq.1)then
        p(i0-2,1:4)=p(ii1-2,1:4)+p(ii2,1:4)
        p(i0,1:4)=p(ii1,1:4)+p(ii2,1:4)
       endif
       if(idir.eq.0)p(i0-2,1:4)=p(i0,1:4)+p(2,1:4)
       
       q=scalar_product(p(i0-2,1:4),p(i0-2,1:4))
       if(q-(q1min+q2min)**2.le.0)then
c ---------------------------------------------------------------
	write(nunit2,*)'--------------------------------------------'
        write(nunit2,*)'warning: 3'
        write(nunit2,*)'q,q1min,q2min,k,i0,i1,m1,i2,m2,i3,m3,ig,idir'
        write(nunit2,*) q,q1min,q2min,k,i0,i1,m1,i2,m2,i3,m3,ig,idir
c ---------------------------------------------------------------
        if(idir.eq.0)iwarning(3)=iwarning(3)+1
        if(idir.eq.1)iwonders(3)=iwonders(3)+1
        iweight=0
        return
       endif
c ---------------------------------------------------------------
       q=dsqrt(q)
      

c ---- boost p2
       
       pboo(4)  =p(i0-2,4)
       pboo(1:3)=-p(i0-2,1:3)
       call boost(q,pboo,p(2,1:4),p2)

       em=parmas(ifl(2))
       e2=p2(4)
       p2e=e2*dsqrt(1-(em/e2)**2)
	
       
       
c ---- generate q2
       
       q2max=q-q1min
       
c print*,'q2max,q2min'
c print*, q2max,q2min 

       if(iq2max.eq.1)q2max=q2min
       if(q2max.gt.q2min)then
        if(idir.eq.1)then
         q2=scalar_product(p(ii2,1:4),p(ii2,1:4)) 
        endif
        if(i3.eq.0)then
         call gen(idir,q2min,q2max,parmas(mm2),parwid(mm2),q2,w_q2)
        elseif(i3.ne.0)then
         call gen(idir,q2min,q2max,r_0,-r_1,q2,w_q2)
        endif
        w_q2=w_q2/(2*pi)
        q2=dsqrt(q2)
       else
        q2=q2min
        w_q2=1
       endif
       
       if(idir.eq.1)then
        q1=scalar_product(p(ii1-2,1:4),p(ii1-2,1:4))
c---------------------------------------------------------------------
        if(q1.lt.q1min**2.and.level(n,ii1-2).gt.1)then
c---------------------------------------------------------------------
	 write(nunit2,*)'---------------------------------------------'
         write(nunit2,*)'warning 18,idir=',idir
         write(nunit2,*)'q1,q1min**2,ii1,ig,k,p(ii1-2,1:4)'
         write(nunit2,*) q1,q1min**2,ii1,ig,k,p(ii1-2,1:4)
c---------------------------------------------------------------------
         if(idir.eq.0)iwarning(18)=iwarning(18)+1
         if(idir.eq.1)iwonders(18)=iwonders(18)+1
         iweight=0
	 return
        endif
c---------------------------------------------------------------------
        t1=scalar_product(p(ii1,1:4),p(ii1,1:4))
       endif


c---------------------------------------------------------------------
c            find limits on t1      
c---------------------------------------------------------------------
       
       if(itogo.eq.1)goto101
       
       
       e2p=q/2+q1min**2/(2*q)-q2**2/(2*q)
       p2p=e2p*dsqrt(1-(q1min/e2p)**2)
       if(q1min.gt.q2)then
        e2p2=q-e2p
        p2p=e2p2*dsqrt(1-(q2/e2p2)**2)
       endif
       
       q1max=q-q2
       q1p=0
       q1m=0

c ---- find t1max

        a_0=1-2*e2/q+(em/q)**2
        a_3=1-e2/q

        dtp=1-e2/q-p2e/q*e2p/p2p
        
        if(dtp.le.0)then
         q1p=q1min**2
         t1max=tfunp(q1p)
        else
         q1p=q**2+q2**2-a_3/dsqrt(a_0)*2*q*q2
         q1p=max(q1min**2,q1p)
         t1max=tfunp(q1p)
        endif
        

c ---- find t1min
         
        dtm=1-e2/q+p2e/q*e2p/p2p
        
        if(dtm.ge.0)then
         q1m=q1min**2
         t1min=tfunm(q1m)
        else
         q1m=q**2+q2**2+a_3/dsqrt(a_0)*2*q*q2
         q1m=max(q1min**2,q1m)
         t1min=tfunm(q1m)
        endif



        ibranch=0
c -------------------------------------------------------------      
c       check for q1-t1  ibranch=1 versus t1-q1 ibranch=0
c -------------------------------------------------------------      

       if(mm10.ne.0)then
        gm1=parmas(mm10)
        gg1=parwid(mm10)
	ibranch=1
       else
        gm1=0
        gg1=-1
cif(gm1.gt.0.and.abs(t1min).gt.0
c..and.abs(t1max/t1min).lt.gg1**2/gm1**2)ibranch=1
       endif
       
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c ---- generate q1-t1
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
       if(ibranch.eq.1)then     !START (001)

c ---- generate q1
       
cq1max=q-q2
       if(q1max.gt.q1min)then
        call gen(idir,q1min,q1max,gm1,gg1,q1,w_q1)
        w_q1=w_q1/(2*pi)
        q1=dsqrt(q1)
       else
        q1=q1min
        w_q1=1
       endif

       
c ---- find t1max t1min

         t1max=tfunp(q1**2)
         t1min=tfunm(q1**2)
         
        
       endif                    !END (001)
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

       
       

c ---- generate t1

      
       if(tm(ii1).ne.0)then
        if(tm(ii1).lt.t1min)then
c ---------------------------------------------------------------
c       print*,'----------------------------------------------------'
c       print*,'warning 4: for t1min < tm(',ii1,') in 1a'
c ---------------------------------------------------------------
         if(idir.eq.0)iwarning(4)=iwarning(4)+1
         if(idir.eq.1)iwonders(4)=iwonders(4)+1
         iweight=-1
         return
        endif
c ---------------------------------------------------------------
        t1max=min(tm(ii1),t1max)
       endif

       t1u=-t1min+parmas(mm1)**2
       t1l=-t1max+parmas(mm1)**2
       if(t1u.lt.t1l)then
c ---------------------------------------------------------------
	write(nunit2,*)'----------------------------------------'
        write(nunit2,*)'warning 16: for t1 in 1a'
        write(nunit2,*)'idir,t1l,t1u,mm1,parmas(mm1)'
        write(nunit2,*)idir,t1l,t1u,mm1,parmas(mm1)
        write(nunit2,*)'ibranch,t1min,t1max'
        write(nunit2,*)ibranch,t1min,t1max
        write(nunit2,*)'q,q1,q2'
        write(nunit2,*)q,q1,q2
c ---------------------------------------------------------------
        if(idir.eq.0)iwarning(16)=iwarning(16)+1
        if(idir.eq.1)iwonders(16)=iwonders(16)+1
        iweight=0
        return
       endif
c ---------------------------------------------------------------
       if(t1l.lt.0)then
c ---------------------------------------------------------------
	write(nunit2,*)'------------------------------------------'
        write(nunit2,*)'warning 5: for t1 in 1'
        write(nunit2,*)'t1min,t1max,q,q2,q2max,q2min,q1max,q1min'
        write(nunit2,*) t1min,t1max,q,q2,q2max,q2min,q1max,q1min
        write(nunit2,*)'q1p,q1m,mm1,e2,p2e,em,e2**2-p2e**2-em**2'
        write(nunit2,*) q1p,q1m,mm1,e2,p2e,em,e2**2-p2e**2-em**2
        write(nunit2,*)'a_0,dtp,dtm'
        write(nunit2,*) a_0,dtp,dtm
        write(nunit2,*)'ig,k,i0,m0,ii1,ii2,i1,m1,i2,m2,i3,m3'
        write(nunit2,*) ig,k,i0,m0,ii1,ii2,i1,m1,i2,m2,i3,m3 
c ---------------------------------------------------------------
c       if(t1l.lt.-eps(0))then
         if(idir.eq.0)iwarning(5)=iwarning(5)+1
         if(idir.eq.1)iwonders(5)=iwonders(5)+1
c ---------------------------------------------------------------
         write(nunit2,*)'idir,ig0,ig,k,i0,mm1,mm10,i1,i2,ii1,ii2'
         write(nunit2,*) idir,ig0,ig,k,i0,mm1,mm10,i1,i2,ii1,ii2
         write(nunit2,*)'ibranch=',ibranch,'eps=',eps(0)
         write(nunit2,*)'t1min,t1max,t1l,q,q1,q2,q1min,em'
         write(nunit2,*) t1min,t1max,t1l,q,q1,q2,q1min,em
         write(nunit2,*)'2*e2',2*e2,em**2-2*e2*q+q**2
         write(nunit2,*)'t = m**2+q**2-2 p e2 ',em**2+q**2-2*q*e2
c ---------------------------------------------------------------
         iweight=0
	 return
c       endif
c ---------------------------------------------------------------
c       t1l=0
       endif
c ---------------------------------------------------------------
       if(idir.eq.1)then
        t1x=-t1+parmas(mm1)**2
        if((t1x.lt.t1l  .or.t1x.gt.t1u  ).or.
     .     (t1 .lt.t1min.or.t1 .gt.t1max))then
          iwonders(25)=iwonders(25)+1
c       print*,'wonders 25'
c       print*,'ig,k,i0,m0,ii1,ii2,i1,m1,i2,m2,i3,m3'
c       print*, ig,k,i0,m0,ii1,ii2,i1,m1,i2,m2,i3,m3 
         iepsilon=0
	 if(    
     .   t1x.lt.t1l.and.t1l-t1x.lt.epsilon(t1l)*(t1u-t1l))then
	  t1x=t1l
          iepsilon=1
         endif
         if(
     .   t1x.gt.t1u.and.t1x-t1u.lt.epsilon(t1l)*(t1u-t1l))then
	  t1x=t1u
          iepsilon=1
         endif
         if(
     .   t1.gt.t1max.and.t1-t1max.lt.epsilon(t1)*(t1max-t1min))then
	  t1=t1max
          iepsilon=1
         endif
         if(
     .   t1.lt.t1min.and.t1min-t1.lt.epsilon(t1)*(t1max-t1min))then
	  t1=t1min
          iepsilon=1
         endif
         if(iepsilon.eq.0)then
	  write(nunit2,*)'--------------------------------------'
          write(nunit2,*)'warning 23'
	  write(nunit2,*)'ig0,ig,k,ibranch,mm1,i0,i1,i2'
	  write(nunit2,*) ig0,ig,k,ibranch,mm1,i0,i1,i2 
	  write(nunit2,*)'t1,t1min,t1max,t1x,t1l,t1u'
	  write(nunit2,*) t1,t1min,t1max,t1x,t1l,t1u 
	  write(nunit2,*)'q,q1,q2,e2,p2e,em'
	  write(nunit2,*) q,q1,q2,e2,p2e,em 
          iwonders(23)=iwonders(23)+1
          iweight=0
	  return
	 endif 
        endif
       endif
c ---------------------------------------------------------------
       call tgen(idir,t1l,t1u,parmas(mm1),t1x,w_t1)
       if(idir.eq.0)then
        t1=-t1x+parmas(mm1)**2
       endif
c ---------------------------------------------------------------
       if(idir.eq.0.and.(t1.ge.t1max.or.t1.le.t1min))then
	write(nunit2,*)'-----------------------------------------'
        write(nunit2,*)'warning 19 :idir',idir
	write(nunit2,*)'ig,k,ibranch,i0,i1,i2,mm1'
	write(nunit2,*) ig,k,ibranch,i0,i1,i2,mm1 
	write(nunit2,*)'t1,t1min,t1max,t1x,t1l,t1u,parmas(mm1)'
	write(nunit2,*) t1,t1min,t1max,t1x,t1l,t1u,parmas(mm1) 
	write(nunit2,*)'q,q1,q2,e2,p2e,em'
	write(nunit2,*) q,q1,q2,e2,p2e,em 
        if(idir.eq.0)iwarning(19)=iwarning(19)+1
c       if(idir.eq.1)iwonders(19)=iwonders(19)+1
	iweight=0
	return
       endif
c ---------------------------------------------------------------
       
c ---------------------------------------------------------------
       if(ibranch.eq.1)goto21    !q1>t1 ENDED
c ---------------------------------------------------------------

c ---------------------------------------------------------------
c ---- generate q1 (t1-q1)       !START(002)
c ---------------------------------------------------------------

       call solve2(t1,y_1,y_2,a_0,istop)

       if(istop.eq.1)then
c ------------------------------------------------------------
	write(nunit2,*)'--------------------------------------'
        write(nunit2,*)'warning 6: stop from solve2'
        write(nunit2,*)t1,y_1,y_2,a_0,q,q2
c ------------------------------------------------------------
        if(idir.eq.0)iwarning(6)=iwarning(6)+1
        if(idir.eq.1)iwonders(6)=iwonders(6)+1
        iweight=0
        return
       endif
c ------------------------------------------------------------

       if(istop.eq.2)then
c ------------------------------------------------------------
	 write(nunit2,*)'-------------------------------------'
         write(nunit2,*)'warning 7: stop from solve2'
         write(nunit2,*)t1,t1min,t1max,a_0,q,q2
c ------------------------------------------------------------
        if(idir.eq.0)iwarning(7)=iwarning(7)+1
        if(idir.eq.1)iwonders(7)=iwonders(7)+1
        iweight=0
        return
       endif
c ------------------------------------------------------------
       
       if(a_0.eq.0)then
       
        if(y_2.gt.0)then
         q1l=q1min**2
         q1u=min(y_1,q1max**2)
        else
         q1l=max(-y_1,q1min**2)
         q1u=q1max**2
        endif
         
c write(nunit2,*)idir,ig,dsqrt(q1u),dsqrt(q1l)
c write(nunit2,*)dsqrt(q1l),dsqrt(q1u),gm1,gg1

        if(q1u-q1l.gt.0)then
c        call gen(idir,dsqrt(q1l),dsqrt(q1u),r_0,r_0,q1,w_q1)
         call gen(idir,dsqrt(q1l),dsqrt(q1u),gm1,gg1,q1,w_q1)      
        else
c ------------------------------------------------------------
	 write(nunit2,*)'-----------------------------------------'
         write(nunit2,*)'warning 8: upper<lower: 1'
         write(nunit2,*)'a_0,q1min**2,y_1,y_2,q1l,q1u'
         write(nunit2,*) a_0,q1min**2,y_1,y_2,q1l,q1u 
         write(nunit2,*)'q,q2,t1,t1min,t1max'
         write(nunit2,*) q,q2,t1,t1min,t1max 
         write(nunit2,*)'ig,k,i0,i1,i2,i3'
         write(nunit2,*) ig,k,i0,i1,i2,i3 
c ------------------------------------------------------------
         if(idir.eq.0)iwarning(8)=iwarning(8)+1
         if(idir.eq.1)iwonders(8)=iwonders(8)+1
         iweight=0
         return
        endif
c ------------------------------------------------------------


       elseif    (a_0.gt.0)then

        q1l=max(q1min**2,y_1)
        q1u=min(q1max**2,y_2)
        
        
        if(q1u-q1l.gt.0)then
c        call gen(idir,dsqrt(q1l),dsqrt(q1u),r_0,r_0,q1,w_q1)
         call gen(idir,dsqrt(q1l),dsqrt(q1u),gm1,gg1,q1,w_q1)
        else
c ------------------------------------------------------------
	 write(nunit2,*)'------------------------------------------'
         write(nunit2,*)'warning 9: upper<lower: 2'
         write(nunit2,*)'a_0,q1min**2,y_1,y_2,q,q2,t1'
         write(nunit2,*) a_0,q1min**2,y_1,y_2,q,q2,t1
         write(nunit2,*)'t1min,t1max,q,q1min,q2,e2,p2e,em'
         write(nunit2,*) t1min,t1max,q,q1min,q2,e2,p2e,em 
         write(nunit2,*)'mm1,ig,idir,k,ibranch,itogo,i0,ii1,ii2'
         write(nunit2,*) mm1,ig,idir,k,ibranch,itogo,i0,ii1,ii2 
         write(nunit2,*)'t1x,t1l,t1u'
         write(nunit2,*) t1x,t1l,t1u 
c ------------------------------------------------------------
         if(idir.eq.0)iwarning(9)=iwarning(9)+1
         if(idir.eq.1)iwonders(9)=iwonders(9)+1
         iweight=0
         return
        endif
c ------------------------------------------------------------

       elseif(a_0.lt.0)then
       
        y_1=min(q1max**2,y_1)
        y_2=max(q1min**2,y_2)

        d_1=y_1-q1min**2
        d_2=q1max**2-y_2
        
c       print*,'---->',a_0,d_1,d_2
        
        
c     ==========  case #1 ================
        if(d_1.gt.0.and.d_2.gt.0)then
         
         if(idir.eq.0)r=rnmy(0)
        
         if(idir.eq.0)then
          icho=2
          if(r.lt.d_1/(d_1+d_2))icho=1
         endif
         
         if(idir.eq.1)then
          if(q1.le.y_1)icho=1
          if(q1.ge.y_2)icho=2
         endif

         if(icho.eq.1)then
c         q1=r*(d_1+d_2)+q1min**2
c         call gen(idir,q1min,dsqrt(y_1),r_0,r_0,q1,w_q1)
          call gen(idir,q1min,dsqrt(y_1),gm1,gg1,q1,w_q1)
          w_q1=w_q1*d_1/(d_1+d_2)
         else
c         q1=r*(d_1+d_2)+y_2-d_1
c         call gen(idir,dsqrt(y_2),q1max,r_0,r_0,q1,w_q1)
          call gen(idir,dsqrt(y_2),q1max,gm1,gg1,q1,w_q1)      
          w_q1=w_q1*d_2/(d_1+d_2)
         endif
        
c        w_q1=d_1+d_2
       
c     ==========  case #2 ================
        elseif(d_1.le.0.and.d_2.gt.0)then
        
c        call gen(idir,dsqrt(y_2),q1max,r_0,r_0,q1,w_q1)
         call gen(idir,dsqrt(y_2),q1max,gm1,gg1,q1,w_q1)      
         
c     ==========  case #3 ================
        elseif(d_1.gt.0.and.d_2.le.0)then
       
c        call gen(idir,q1min,dsqrt(y_1),r_0,r_0,q1,w_q1)
         call gen(idir,q1min,dsqrt(y_1),gm1,gg1,q1,w_q1)      
         
c     ==========  case #4 ================
        elseif(d_1.le.0.and.d_2.le.0)then
       
c ------------------------------------------------------------
	 write(nunit2,*)'----------------------------------------'
         write(nunit2,*)'warning 10: something is wrong'
         write(nunit2,*)'ig,k,i0,i1,i2,i3,idir,ii1,ii2,mm1,mm2'
         write(nunit2,*) ig,k,i0,i1,i2,idir,ii1,ii2,mm1,mm2
         write(nunit2,*)'ibranch',ibranch
         write(nunit2,*)'q,t1,t1min,t1max'
         write(nunit2,*) q,t1,t1min,t1max 
         write(nunit2,*)'q1,q1min,q1max'
         write(nunit2,*) q1,q1min,q1max 
         write(nunit2,*)'q2,q2min,q2max'
         write(nunit2,*) q2,q2min,q2max 
         write(nunit2,*)'a_0,d_1,d_2,y_1,y_2,dtp,dtm'
         write(nunit2,*) a_0,d_1,d_2,y_1,y_2,dtp,dtm 
c        print*,'p------------------------'
c        print'(i4,4e15.8)',(l,p(l,1:4),l=1,2**n-2)
c ------------------------------------------------------------
         if(idir.eq.0)iwarning(10)=iwarning(10)+1
         if(idir.eq.1)iwonders(10)=iwonders(10)+1
         iweight=0
         return
        endif
c ------------------------------------------------------------
     
       endif
       


       q1=dsqrt(q1)
       w_q1=w_q1/(2*pi)
       
       
c ---------------------------------------------------------------
c ---- generate q1 (t1-q1)       !END(002)
c ---------------------------------------------------------------
  21    continue
       
c ---------------------------------------------------------------
c ---- solve for costh           !START(003)
c ---------------------------------------------------------------

       if(idir.eq.0)then
	t1p=tfunp(q1**2)
	t1m=tfunm(q1**2)
        cth=costh(q1,t1)

        if(dabs(cth).gt.1)then
         if(dabs(cth-1).lt.eps(0))then
c ------------------------------------------------------------
	  write(nunit2,*)'------------------------------------------'
          write(nunit2,*)'warning 17: 1',cth
          write(nunit2,*)'q,q1,q2,t1p,t1m,t1,em,e2,p2e'
          write(nunit2,*) q,q1,q2,t1p,t1m,t1,em,e2,p2e 
c         print*,'q,q1,q2,xx1,xx2,t1,em,e2,p2e'
c         print*, q,q1,q2,xx1,xx2,t1,em,e2,p2e 
c ------------------------------------------------------------
          if(idir.eq.0)iwarning(17)=iwarning(17)+1
c         if(idir.eq.1)iwonders(17)=iwonders(17)+1
          cth=1
         else
c ------------------------------------------------------------
	  write(nunit2,*)'------------------------------------------'
          write(nunit2,*)'warning 11'
          write(nunit2,*)'ig,k,ibranch,idir,mm10'
          write(nunit2,*) ig,k,ibranch,idir,mm10
          write(nunit2,*)'cth,t1,q,q1,q2,t1min,t1max,mm1,parmas(mm1)'
          write(nunit2,*) cth,t1,q,q1,q2,t1min,t1max,mm1,parmas(mm1)
          write(nunit2,*)'q1min,q1max,q1l,q1u'
          write(nunit2,*) q1min,q1max,q1l,q1u,a_0,y_1,y_2,gm1,gg1
          write(nunit2,*)'a_0,y_1,y_2,gm1,gg1,d_1,d_2'
          write(nunit2,*) a_0,y_1,y_2,gm1,gg1,d_1,d_2
          write(nunit2,*)'d_1=y_1-q1min**2'
          write(nunit2,*)'d_2=q1max**2-y_2'
          write(nunit2,*)'e2,p2e,em'
          write(nunit2,*) e2,p2e,em
          write(nunit2,*)'t1x,t1l,t1u,parmas(mm1)**2'
          write(nunit2,*) t1x,t1l,t1u,parmas(mm1)**2
c ---------------------------------------------------------------
         if(idir.eq.0)iwarning(11)=iwarning(11)+1
c        if(idir.eq.1)iwonders(11)=iwonders(11)+1
         iweight=0
         return
         endif
c ------------------------------------------------------------
        endif
       endif

       
c ---------------------------------------------------------------
c ---- solve for costh           !END(003)
c ---------------------------------------------------------------
       goto 102
       
 101   continue
c ---------------------------------------------------------------
c ---- q1>t1 in case q1 is external  !START(004)
c ---------------------------------------------------------------
 
       q1=q1min
 
       t1max=tfunp(q1**2)
       t1min=tfunm(q1**2)
     
       if(tm(ii1).ne.0)then
        if(tm(ii1).lt.t1min)then
c ---------------------------------------------------------------
         if(idir.eq.0)iwarning(21)=iwarning(21)+1
         if(idir.eq.1)iwonders(21)=iwonders(21)+1
         iweight=-1
         return
        endif
c ---------------------------------------------------------------
        t1max=min(tm(ii1),t1max)
       endif
       
       if(idir.eq.1)t1=scalar_product(p(ii1,1:4),p(ii1,1:4))
       
       
       t1u=-t1min+parmas(mm1)**2
       t1l=-t1max+parmas(mm1)**2
       if(t1u.lt.t1l)then
c ------------------------------------------------------------------
c       print*,'warning: for t1 in 2a'
c ------------------------------------------------------------------
        if(idir.eq.0)iwarning(12)=iwarning(12)+1
        if(idir.eq.1)iwonders(12)=iwonders(12)+1
        iweight=0
        return
       endif
c ------------------------------------------------------------------
       if(t1l.lt.0)then
c ------------------------------------------------------------------
c       print*,'warning: for t1 in 2'
c       print*,'t1min,t1max,q,q2,q2max,q2min,q1max,q1min'
c       print*,t1min,t1max,q,q2,q2max,q2min,q1max,q1min
c       print*,'ig,k,i0,m0,i1,m1,i2,m2,i3,m3'
c       print*, ig,k,i0,m0,i1,m1,i2,m2,i3,m3 
c ------------------------------------------------------------------
        if(idir.eq.0)iwarning(13)=iwarning(13)+1
        if(idir.eq.1)iwonders(13)=iwonders(13)+1
        t1l=0
       endif
c ------------------------------------------------------------------
       if(idir.eq.1)then
        t1x=-t1+parmas(mm1)**2
        if(t1x.lt.t1l.or.t1x.gt.t1u)then
         iwonders(24)=iwonders(24)+1
         iweight=0
         return
        endif
       endif
c ------------------------------------------------------------------
       call tgen(idir,t1l,t1u,parmas(mm1),t1x,w_t1)
       if(idir.eq.0)t1=-t1x+parmas(mm1)**2
c ---------------------------------------------------------------
       if(t1.ge.t1max.or.t1.le.t1min)then
        if(idir.eq.0)iwarning(20)=iwarning(20)+1
        if(idir.eq.1)iwonders(20)=iwonders(20)+1
	iweight=0
	return
       endif
c ---------------------------------------------------------------
       
       if(idir.eq.0)then
        cth=costh(q1,t1)

        if(dabs(cth).gt.1)then
         if(dabs(cth-1).lt.eps(0))then
c ------------------------------------------------------------
c         print*,'XXXXXXXXX: 2',cth
c ------------------------------------------------------------
          if(idir.eq.0)iwarning(14)=iwarning(14)+1
          if(idir.eq.1)iwonders(14)=iwonders(14)+1
          cth=1
         else
c ------------------------------------------------------------
c         print*,'2,cth,t1,q,q1,q2,t1min,t1max,mm1,parmas(mm1)'
c         print*,cth,t1,q,q1,q2,t1min,t1max,mm1,parmas(mm1)
c         print*,'e2,p2e,cth_num,cth_den'
c         print*,e2,p2e,cth_num,cth_den
c         print*,t1x,t1l,t1u,parmas(mm1)**2
c ------------------------------------------------------------
          if(idir.eq.0)iwarning(15)=iwarning(15)+1
          if(idir.eq.1)iwonders(15)=iwonders(15)+1
          iweight=0
	  return
         endif
c ------------------------------------------------------------
        endif
       endif
       
c ---------------------------------------------------------------
c ---- q1>t1 in case q1 is external  !END(004)
c ---------------------------------------------------------------
 102   continue
 
c ---- generate phi


       if(idir.eq.0)then
        r=rnmy(0)
        phi=2*pi*r
       endif
       w_phi=2*pi
       
       
       if(idir.eq.0)then

       
       sth=dsqrt(1-cth*cth)
       p(ii1-2,4)=q/2+q1**2/q/2-q2**2/q/2
       p(ii2,4)= q-p(ii1-2,4)
       pm=p(ii1-2,4)*dsqrt(1-(q1/p(ii1-2,4))**2)
       rewind(100)
cwrite(100,*)p(ii1-2,4),pm,q1,p(ii1-2,4)**2-pm**2-q1**2
       if(q2.gt.q1)pm=p(ii2,4)*dsqrt(1-(q2/p(ii2,4))**2)
cwrite(100,*)p(ii2,4),pm,q2,p(ii2,4)**2-pm**2-q2**2
       
       p(ii1-2,3)=pm*cth
       p(ii1-2,2)=pm*sth*dsin(phi)
       p(ii1-2,1)=pm*sth*dcos(phi)
       p(ii2,1:3)=-p(ii1-2,1:3)

c ---- rotate 

       cth0=p2(3)/dsqrt(p2(1)**2+p2(2)**2+p2(3)**2)
       if(p2(1)**2+p2(2)**2.eq.0)then
        if(p2(3).gt.0)cth0=1
        if(p2(3).lt.0)cth0=-1
       endif
       phi0=ph4(p2(1),p2(2),p2(3))
       
       call rotate(cth0,dcos(phi0),dsin(phi0),p(ii1-2,1:3))
       call rotate(cth0,dcos(phi0),dsin(phi0),p(ii2,1:3))
       
c ---- boost to the over all frame

       pboo(1:4)=p(i0-2,1:4)
       pq=dsqrt( scalar_product(pboo,pboo) )
       call boostl(pq,pboo,p(ii1-2,1:4))
       call boostl(pq,pboo,p(ii2,1:4))
       
       t1new=scalar_product(p(ii1-2,1:4),p(ii1-2,1:4))
     .       +scalar_product(p(2,1:4),p(2,1:4))
     .     -2*scalar_product(p(ii1-2,1:4),p(2,1:4))


       data it1new/0/
       if(abs((t1new-t1)/t1).gt.1.and.it1new.lt.10)then
        it1new=it1new+1
        write(nunit2,*)'<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<'
        write(nunit2,*)'abs((t1new-t1)/t1),t1,t1new'
        write(nunit2,*) abs((t1new-t1)/t1),t1,t1new
        write(nunit2,*)'t1min,t1max,q2max,q2min,q1max,q1min'
        write(nunit2,*) t1min,t1max,q2max,q2min,q1max,q1min 
        write(nunit2,*)'q,q1,q2'
        write(nunit2,*) q,q1,q2 
        write(nunit2,*)'ig,k,i0,m0,i1,m1,i2,m2,i3,m3'
        write(nunit2,*) ig,k,i0,m0,i1,m1,i2,m2,i3,m3 
        write(nunit2,*)'try an other set of cuts'
        write(nunit2,*)'OR change to QP mode'
        write(nunit2,*)'>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>'
c       stop
       endif

       endif
       
c ---- calculate total weight
       
       weight=weight*w_q1*w_q2*w_t1*w_phi/q/p2e
     .       /(32*pi**2)
     
c print*,'weight,w_q1,w_q2,w_t1,w_phi,q,p2e'
c print*, weight,w_q1,w_q2,w_t1,w_phi,q,p2e
       
       if(idir.eq.0)then
       if(j1.eq.1)then
        p(i1,1:4)=p(ii1-2,1:4)-p(2,1:4)
       elseif(j2.eq.1)then
        p(i2,1:4)=p(ii1-2,1:4)-p(2,1:4)
       elseif(j3.eq.1)then
        p(i3,1:4)=p(ii1-2,1:4)-p(2,1:4)
       endif
       endif
       
       
c ---------------------------------------------------------------
c Go back (11) to generate the cluster of two if i3=/=0
c VVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVV
       if(i3.ne.0)then
        i0=ii2
       if(j1.eq.1)then
        i1=i2
        m1=m2
        i2=i3
        m2=m3
       elseif(j2.eq.1)then
        i1=i1
        i2=i3
        m2=m3
       elseif(j3.eq.1)then
        i1=i1
        i2=i2
       endif
        i3=0
        m3=0
       goto11
       endif
c ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
c Go back (11) to generate the cluster of two if i3=/=0
c ---------------------------------------------------------------
       
       if(idir.eq.1)then
        k=k-1
        goto10
       endif
        
       k=k+1
       goto10      
      
      
       endif
      

 1000  continue
      
       if(weight.eq.0)then
	iweight=0
        if(idir.eq.0)iwarning(22)=iwarning(22)+1
        if(idir.eq.1)iwonders(22)=iwonders(22)+1
	return
       endif

c ---- define zq's 

       do i=3,n
       	j=2**(i-1)
       	pt=dsqrt(p(j,1)**2+p(j,2)**2)
       	pq=dsqrt(pt**2+p(j,3)**2)
       	zq(i,1)= dcmplx(p(j,4)+p(j,3),p(j,3))
       	zq(i,2)= dcmplx(p(j,4)-p(j,3),pt)
       	zq(i,3)= dcmplx(p(j,1), p(j,2))
       	zq(i,4)= dcmplx(p(j,1),-p(j,2))
       	zq(i,5)= dcmplx( parmas(ifl(i)) , pq )
       	pmom(i,1:4)=p(j,1:4)
       	pmom(i,5)=parmas(ifl(i))
       enddo  
       
      
       
       return
       end
       
       function tfunm(x)
       include 'declare.h'
       common/phegas1/q,q2,e2,em
        
        
        p2=e2*dsqrt(1-(em/e2)**2)

       xx1=(q**2+x-q2**2)
       xx2=xx1*dsqrt(1-(2*q/xx1)**2*x)
       tfunm=em*em+x-e2/q*xx1-p2/q*xx2
       
       return
       end
       
c This rotates a vector an angle theta around Y and ph around Z
c so that a (0,0,1) -> (sin(th)cos(ph),sin(th)sin(ph),cos(th))

       subroutine rotate(cth,cph,sph,a)
       include 'declare.h'

       dimension a(3),b(3)
       sth=dsqrt(1-cth*cth)
       b(1)= a(1)*cth*cph-a(2)*sph+a(3)*sth*cph
       b(2)= a(1)*cth*sph+a(2)*cph+a(3)*sth*sph
       b(3)=-a(1)*sth             +a(3)*cth
       a(1:3)=b(1:3)
       return
       end

c This rotates a vector an angle -ph around Z and -th around Y
c so that a (sin(th)cos(ph),sin(th)sin(ph),cos(th)) -> (0,0,1)

       subroutine rotate_inv(cth,cph,sph,a)
       include 'declare.h'

       dimension a(3),b(3)
       sth=dsqrt(1-cth*cth)
       b(1)= a(1)*cth*cph+a(2)*cth*sph-a(3)*sth
       b(2)=-a(1)*sph    +a(2)*cph    
       b(3)= a(1)*sth*cph+a(2)*sth*sph+a(3)*cth
       a(1:3)=b(1:3)
       return
       end
       
       
       subroutine twobody(idir,q,q1,q2,p1,p2,w)
       include 'declare.h'

       dimension p1(4),p2(4)
       data init/0/
       save pi
       
       r_0=0
       r_1=1
      
       if(init.eq.0)then
        call mypi(pi)
        init=1
       endif
       
       w=0
       if(q.le.q1+q2)return
       
       e1=(q**2+q1**2-q2**2)/q/2
       e2=q-e1
       p=e1*dsqrt(1-(q1/e1)**2)
       if(q1.gt.q2)p=e2*dsqrt(1-(q2/e2)**2)

       
       w=p/q/(4*pi)
       
c      print*,'in twobody',q,q1,q2,p,w
       
       if(idir.eq.1)return
       
       p1(4)=e1
       p2(4)=e2
       
       r1=rnmy(0)
       r2=rnmy(0)

       
       cth=2*r1-1
       sth=dsqrt(1-cth*cth)
        ph=2*pi*r2
       
       
       p1(3)=p*cth
       p1(2)=p*sth*dsin(ph)
       p1(1)=p*sth*dcos(ph)
       
       p2(1:3)=-p1(1:3)
       
       
       return
       end
       
       subroutine tgen(idir,xl,xu,gm,x,w)
       include 'declare.h'
       include 'common_print.h'

       data init/0/
       save ex
       
       r_0=0
       r_1=1

       ex=dnou(95)/100
       if(gm.eq.0)ex=dnou(5)/100

       
       if(init.eq.0)then
        write(nunit2,*)'ex=',ex,1-ex
        init=1
       endif
       
       if(idir.eq.0)then
        r=rnmy(0)
        x=(r * xu**ex + (r_1-r) * xl**ex)**(r_1/ex)
       endif
       
       w=(xu**ex-xl**ex) * x**(1-ex) /ex

c      if(idir.eq.0)print*,r,xl,xu,gm,x,w
c      if(x.ge.xu.or.x.le.xl)then
c       print*,'r,x,xu,xl,w'
c       print*, idir,r,x,xu,xl,w
c      endif

       return
       end
       
       subroutine gen(idir,x0,x1,xm,gm,x,w)
       include 'declare.h'

       r_0=0
       r_1=1
       
       if(xm.gt.0.and.gm.gt.0.and.x1/xm.gt.r_1/100)then

       xu=datan( (x1**2-xm**2)/(xm*gm) )
       xl=datan( (x0**2-xm**2)/(xm*gm) )


       if(idir.eq.0)then
        r=rnmy(0)
        x=xm**2+xm*gm*tan(r*xu+(r_1-r)*xl)
       endif

       w=(x-xm**2)**2+xm**2*gm**2
       w=w/xm/gm*(xu-xl)


       else
      
        ex=dnou(95)/100
	if(gm.eq.0)ex=dnou(1)/100

        xu=x1**2
        xl=x0**2
        if(idir.eq.0)then
         r=rnmy(0)
         x=( xu**ex *  r + (r_1-r) * xl**ex )**(r_1/ex)
        endif
        w=x**(r_1-ex)*(xu**ex-xl**ex)/ex
       

       endif

c      if(idir.eq.0)then
c      print*,'in gen,idir,ex,x0,x1,xl,xu,r,x,sqrt(x),w'
c      print*,        idir,ex,x0,x1,xl,xu,r,x,sqrt(x),w
c      endif

     
       return

       
       end
      
       subroutine threebody(idir,q,q1,q2,q3,q23,p1,p2,p3,w)
       include 'declare.h'

       dimension p1(4),p2(4),p3(4),p23(4)
       data init/0/
       save pi
       
       r_0=0
       r_1=1
       
       if(init.eq.0)then
        call mypi(pi)
        init=1
       endif
       
       
       q23min=q2+q3
       q23max=q-q1
       call gen(idir,q23min,q23max,r_0,-r_1,q23,w_23)
       w_23=w_23/(2*pi)
       q23=dsqrt(q23)
       
       call twobody(idir,q23,q2,q3,p2,p3,w_2)
       call twobody(idir,q,q1,q23,p1,p23,w_1)
       
       w=w_23*w_1*w_2
      
       if(idir.eq.1)return
       
       call boostl(q23,p23,p2(1:4))
       call boostl(q23,p23,p3(1:4))
       
       
       return
       end
       
       function clambda(x1,x2,x3)
       include 'declare.h'
       include 'common_print.h'
       
       if(x2.lt.eps(0).and.x3.lt.eps(0))then
        clambda=x1
        return
       endif
       if(x2.lt.eps(0))then
        clambda=x1-x3
        return
       endif
       if(x3.lt.eps(0))then
        clambda=x1-x2
        return
       endif

       f=x1**2+x2**2+x3**2
     .  -2*x1*x2-2*x1*x3-2*x2*x3
       
       if(f.le.0)then
        write(nunit2,*)'warning in clambda: f,x1,x2,x3',f,x1,x2,x3
        stop
       endif
       
       clambda=dsqrt(f)
       
       return
       end
       

       subroutine setmin(cmas)
       include 'declare.h'
       include 'common_masses.h'
       include 'common_int.h'
       include 'common_phegas_mom.h'
       include 'common_cuts.h'
       integer y0(20),y1(20),y2(20)
       dimension cmas(*)
       data init/0/
       
       if(init.eq.0)then
        y0(1:20)=0
        y1(1:20)=0
        y2(1:20)=0
cprint*,parmas
        init=1
       endif
       
       do l=1,n-1
       
       ix1=0
       do while(ix1.eq.0)
       
       call id(n,l,ix1,i0)
c      print*,n,l,ix1,i0
       if(ix1.eq.1)cycle
      

       if(mod(i0,4).ne.0)cycle
       
       if(l.eq.1)then
       call bin(n,i0,y0)
       do k=1,n
         if(y0(k).ne.0)j0=n-k+1
       enddo
       cmas(i0)=parmas(ifl(j0))
       endif
       
       if(l.lt.2)cycle
       
       ix2=0
       do while(ix2.eq.0)
       
       call id2(n,l,i0,ix2,i1,i2)
c      print*,n,l,i0,ix2,i1,i2
       if(ix2.eq.1)cycle
       
       
       if(level(n,i1).eq.1.and.level(n,i2).eq.1)then
        call bin(n,i1,y1)
        call bin(n,i2,y2)
        do k=1,n
         if(y1(k).ne.0)j1=n-k+1
         if(y2(k).ne.0)j2=n-k+1
        enddo
        rm1=parmas(ifl(j1))
        rm2=parmas(ifl(j2))
        if(rm1.eq.0.and.rm2.eq.0)then
        e1=ec(j1)
        e2=ec(j2)
        p1=0
        p2=0
        if(e1.gt.0)p1=e1*dsqrt(1-(rm1/e1)**2)
        if(e2.gt.0)p2=e2*dsqrt(1-(rm2/e2)**2)
        x=rm1**2+rm2**2+2*e1*e2-2*p1*p2*cc(j1,j2)
        cmas(i0)=max(dsqrt(x),gmas(j1,j2),cmas(i1)+cmas(i2))
        else
        cmas(i0)=max(gmas(j1,j2),cmas(i1)+cmas(i2))
        endif
       else
        cmas(i0)=max(cmas(i0),cmas(i1)+cmas(i2))
       endif
       
       
       enddo
       
              
       enddo
 
       enddo
       
       return
       end
       
       subroutine setmax(tm,cmas)
       include 'declare.h'
       include 'common_masses.h'
       include 'common_int.h'
       include 'common_print.h'
       include 'common_phegas_mom.h'
       include 'common_cuts.h'
       dimension tm(*),cmas(*)
       save init
       data init/0/
       
       w=2*scalar_product(pmom(1,1:4),pmom(2,1:4))
     .  +  scalar_product(pmom(1,1:4),pmom(1,1:4))
     .  +  scalar_product(pmom(2,1:4),pmom(2,1:4))
       w=dsqrt(w)

       do i=3,n
       
       l=2**(i-1)
       i0=2**n-2-l

       rm1=parmas(ifl(1))
       rm2=parmas(ifl(i))
       q2=cmas(i0-2)**2
       e1=pmom(1,4)
       e2=(w**2+rm2**2-q2)/2/w
       if(init.eq.0)then
       write(nunit2,*)'i,i0,2**n-2-l-2,q2,w,e1,e2'
       write(nunit2,*) i,i0,2**n-2-l-2,q2,w,e1,e2
       endif
       p1=0
       p2=0
       if(e1.gt.0)p1=e1*dsqrt(1-(rm1/e1)**2)
       if(e2.gt.0)p2=e2*dsqrt(1-(rm2/e2)**2)
       
       dtp=e1/w-p1/p2*(w**2+rm2**2-q2)/(2*w**2)*c1(i)       
       if(init.eq.0)write(nunit2,*)'dtp',dtp
       if(dtp.gt.0)then
        alpha=1-p1**2*c1(i)/e1**2
        if(alpha.gt.0)then
        q2=dmax1(
     .    w**2+rm2**2-2*w*rm2/dsqrt(alpha)
     .   ,q2)
        if(q2.gt.w**2-2*w*ec(i))q2=w**2-2*w*ec(i)
        else
        q2=w**2-2*w*ec(i)
        endif
        e2=(w**2+rm2**2-q2)/2/w
        p2=0
        if(e2.gt.0)p2=e2*dsqrt(1-(rm2/e2)**2)
       endif

       tm(i0)=rm1**2+rm2**2-2*e1*e2+2*p1*p2*c1(i)
       if(e1*e2.gt.0.and.rm1.gt.0.and.rm2.gt.0.and.
     . rm1/e1.lt.1/dnou(1000).and.rm2/e2.lt.1/dnou(1000))then
       tm(i0)=rm1**2*(1-e2/e1)+rm2**2*(1-e1/e2)
     .       -rm1**4*e2/4/e1**3
     .       -rm2**4*e1/4/e2**3
     .       +rm1**2*rm2**2/2/e1/e2
       endif
       if(init.eq.0)then
       write(nunit2,*)'i0,rm1,rm2,e1,e2,p1,p2,c1(i),tm(i0)'
       write(nunit2,*) i0,rm1,rm2,e1,e2,p1,p2,c1(i),tm(i0)
       endif

       i0=l+2

       rm1=parmas(ifl(2))
       rm2=parmas(ifl(i))
       q2=cmas(i0-2)**2
       e1=pmom(2,4)
       e2=(w**2+rm2**2-q2)/2/w
       if(init.eq.0)then
       write(nunit2,*)'i,i0,2**n-2-l-2,q2,w,e1,e2'
       write(nunit2,*) i,i0,2**n-2-l-2,q2,w,e1,e2
       endif
       p1=0
       p2=0
       if(e1.gt.0)p1=e1*dsqrt(1-(rm1/e1)**2)
       if(e2.gt.0)p2=e2*dsqrt(1-(rm2/e2)**2)
       
       dtp=e1/w-p1/p2*(w**2+rm2**2-q2)/(2*w**2)*c2(i)       
       if(dtp.gt.0)then
        alpha=1-p1**2*c2(i)/e1**2
        if(alpha.gt.0)then
        q2=dmax1(
     .    w**2+rm2**2-2*w*rm2/dsqrt(alpha)
     .   ,q2)
        if(q2.gt.w**2-2*w*ec(i))q2=w**2-2*w*ec(i)
        else
        q2=w**2-2*w*ec(i)
        endif
        e2=(w**2+rm2**2-q2)/2/w
        p2=0
        if(e2.gt.0)p2=e2*dsqrt(1-(rm2/e2)**2)
       endif

       
       tm(i0)=rm1**2+rm2**2-2*e1*e2+2*p1*p2*c2(i)
       if(e1*e2.gt.0.and.rm1.gt.0.and.rm2.gt.0.and.
     . rm1/e1.lt.1/dnou(1000).and.rm2/e2.lt.1/dnou(1000))then
       tm(i0)=rm1**2*(1-e2/e1)+rm2**2*(1-e1/e2)
     .       -rm1**4*e2/4/e1**3
     .       -rm2**4*e1/4/e2**3
     .       +rm1**2*rm2**2/2/e1/e2
       endif
       
       if(init.eq.0)then
       write(nunit2,*)'i0,rm1,rm2,e1,e2,p1,p2,c2(i),tm(i0)'
       write(nunit2,*) i0,rm1,rm2,e1,e2,p1,p2,c2(i),tm(i0)
       endif
       
       enddo
       
       init=1

       return
       end
       
      subroutine look(is,k,i1,mm) 
      integer is(8,8)

      mm=0
      do i=k,8
       if(is(i,1).eq.i1)then
        if(is(i,7).ne.0)return
        if(is(i,3).eq.2) mm=is(i,6) 
        if(is(i,5).eq.2) mm=is(i,4) 
       endif
      enddo
     
      return
      end
C---------------------------------------------------------------
      SUBROUTINE BOOST(Q,PBOO,PCM,PLB)
      include 'declare.h'
      dimension PBOO(4),PCM(4),PLB(4)
         
	 PLB(4)=(PBOO(4)*PCM(4)+PBOO(3)*PCM(3)
     .             +PBOO(2)*PCM(2)+PBOO(1)*PCM(1))/Q
         FACT=(PLB(4)+PCM(4))/(Q+PBOO(4))
         DO 10 J=1,3
  10     PLB(J)=PCM(J)+FACT*PBOO(J)

      RETURN
      END
c ----------------------------------------------------------------------
      SUBROUTINE BOOSTL(Q,PBOO,P)
      include 'declare.h'
      dimension PBOO(4),PCM(4),PLB(4),P(4)
         
         PCM(1:4)=P(1:4)
	 PLB(4)=(PBOO(4)*PCM(4)+PBOO(3)*PCM(3)
     .             +PBOO(2)*PCM(2)+PBOO(1)*PCM(1))/Q
         FACT=(PLB(4)+PCM(4))/(Q+PBOO(4))
         DO 10 J=1,3
  10     PLB(J)=PCM(J)+FACT*PBOO(J)
         P(1:4)=PLB(1:4)

      RETURN
      END
c ----------------------------------------------------------------------
       
       FUNCTION ph4(px,py,pz)
       include 'declare.h'
       data init/0/
       save pi
       if(init.eq.0)then
        call mypi(pi)
        init=1
       endif
       if(px**2+py**2.le.0)then
       if(pz.ge.0)ph4=0
       if(pz.lt.0)ph4=pi
       return
       endif
       S=px/DSQRT(px**2+py**2)
       ph4=DACOS(S)
       IF(py.LT.0)ph4=2*pi-ph4
       RETURN
       END
c ----------------------------------------------------------------------
