******************************************************************
*  Be careful that dconjg(eminus) =/= eplus
*  because we are working in the rotated lightcone frame
*  where for the 3- and 4-  component there is an extra
*  imaginary unit in its definition
******************************************************************

       subroutine wave_functions
       include 'declare.h'
       dimension zy(4),zq(5)
       
       return
       entry eminus(zy,zq)
      
       
       
       pt=dimag(zq(2))
       pz=dimag(zq(1))
       p =dimag(zq(5))
       p0=dreal(zq(1))-pz
      
       if(p.gt.eps(1))then
       
       if(pt.gt.eps(1))then
       
       zy(1)=-pt/p/dsqrt(dnou(2))
       zy(2)= pt/p/dsqrt(dnou(2))
       zy(3)=zq(3)*( p+pz)/p/pt/dsqrt(dnou(2))
       zy(4)=zq(4)*(-p+pz)/p/pt/dsqrt(dnou(2))
       
       else
       
       if(pz.gt.dnou(0))then
       zy(1)=dcmplx(dnou(0),dnou(0))
       zy(2)=dcmplx(dnou(0),dnou(0))
       zy(3)=dcmplx(dsqrt(dnou(2)),dnou(0))
       zy(4)=dcmplx(dnou(0),dnou(0))
       else
       zy(1)=dcmplx(dnou(0),dnou(0))
       zy(2)=dcmplx(dnou(0),dnou(0))
       zy(3)=dcmplx(dnou(0),dnou(0))
       zy(4)=dcmplx(dsqrt(dnou(2)),dnou(0))
       endif
       
       endif
       
       
       else
       
       if(p0.gt.eps(1))then
       zy(1)=dcmplx(dnou(0),dnou(0))
       zy(2)=dcmplx(dnou(0),dnou(0))
       zy(3)=dcmplx(dsqrt(dnou(2)),dnou(0))
       zy(4)=dcmplx(dnou(0),dnou(0))
       else
       zy(1)=dcmplx(dnou(0),dnou(0))
       zy(2)=dcmplx(dnou(0),dnou(0))
       zy(3)=dcmplx(dnou(0),dnou(0))
       zy(4)=dcmplx(dnou(0),dnou(0))
       endif
       
       endif
       
       return
       
       entry eplus(zy,zq)
      
      
       pt=dimag(zq(2))
       pz=dimag(zq(1))
       p =dimag(zq(5))
       p0=dreal(zq(1))-pz
      
       
       if(p.gt.eps(1))then
       
       if(pt.gt.eps(1))then
      
       zy(1)= pt/p/dsqrt(dnou(2))
       zy(2)=-pt/p/dsqrt(dnou(2))
       zy(3)=zq(3)*( p-pz)/p/pt/dsqrt(dnou(2))
       zy(4)=zq(4)*(-p-pz)/p/pt/dsqrt(dnou(2))
       
       else
       
       if(pz.gt.dnou(0))then
       zy(1)=dcmplx(dnou(0),dnou(0))
       zy(2)=dcmplx(dnou(0),dnou(0))
       zy(3)=dcmplx(dnou(0),dnou(0))
       zy(4)=-dcmplx(dsqrt(dnou(2)),dnou(0))
       else
       zy(1)=dcmplx(dnou(0),dnou(0))
       zy(2)=dcmplx(dnou(0),dnou(0))
       zy(3)=-dcmplx(dsqrt(dnou(2)),dnou(0))
       zy(4)=dcmplx(dnou(0),dnou(0))
       endif
      
       endif
       
       else
       
       if(p0.gt.eps(1))then
       zy(1)=dcmplx(dnou(0),dnou(0))
       zy(2)=dcmplx(dnou(0),dnou(0))
       zy(3)=dcmplx(dnou(0),dnou(0))
       zy(4)=-dcmplx(dsqrt(dnou(2)),dnou(0))
       else
       zy(1)=dcmplx(dnou(0),dnou(0))
       zy(2)=dcmplx(dnou(0),dnou(0))
       zy(3)=dcmplx(dnou(0),dnou(0))
       zy(4)=dcmplx(dnou(0),dnou(0))
       endif
       
       
       endif
       
     
       return

       entry elong(zy,zq)
      
       
       pt=dimag(zq(2))
       pz=dimag(zq(1))
       p =dimag(zq(5))
       p0=dreal(zq(1))-pz
       p2=p0*p0-p*p
       
       if(p2.gt.eps(1))then
        p2=dsqrt(p2)
        
        if(p.gt.eps(1))then
       
        zy(1)=p/p2+pz*p0/(p*p2)
        zy(2)=p/p2-pz*p0/(p*p2)
        zy(3)=p0*zq(3)/(p*p2)
        zy(4)=p0*zq(4)/(p*p2)
       
        else
       
        zy(1)=dcmplx(dnou(1),dnou(0))
        zy(2)=dcmplx(-dnou(1),dnou(0))
        zy(3)=dcmplx(dnou(0),dnou(0))
        zy(4)=dcmplx(dnou(0),dnou(0))
        
        endif
       
       else
              
       zy(1:4)=dcmplx(dnou(0),dnou(0))
       
       endif
       

       return
       
       
       entry uplus(zy,zq)

       
       emass=dreal(zq(5))
       
       if(emass.ne.dnou(0))then
       
       b=dimag(zq(5))+dimag(zq(1))
       
       if(b.gt.eps(1))then
         
         a=b+dreal(zq(2))
         c=a+b-dreal(zq(1))
         r=dsqrt(a*b*c)

         zy(1)= r/c
         zy(2)= zq(3)*a/r
         zy(3)=-emass*b/r
         zy(4)=-emass*zq(3)/r
        
        else

         a=b+dreal(zq(2))
         
         zy(1)=dcmplx(dnou(0),dnou(0))
         zy(2)=-dsqrt(a)
         zy(3)=dcmplx(dnou(0),dnou(0))
         zy(4)=emass/dsqrt(a)
       
        endif

       else

       call ru(zy,zq)
       endif
       
      
       return

       entry ubplus(zy,zq)
       
       
       emass=dreal(zq(5))
       
       if(emass.ne.dnou(0))then
       
       b=dimag(zq(5))+dimag(zq(1))
       
       if(b.gt.eps(1))then
         
         a=b+dreal(zq(2))
         c=a+b-dreal(zq(1))
         r=dsqrt(a*b*c)

         zy(1)= emass*b/r
         zy(2)= emass*zq(4)/r
         zy(3)=-r/c
         zy(4)=-zq(4)*a/r
        
        else

         a=b+dreal(zq(2))
         
         zy(1)=dcmplx(dnou(0),dnou(0))
         zy(2)=-emass/dsqrt(a)
         zy(3)=dcmplx(dnou(0),dnou(0))
         zy(4)= dsqrt(a)
       
        endif

       else

       call rub(zy,zq)
       
       endif
      
       return
       
       entry uminus(zy,zq)
       
       
       emass=dreal(zq(5))
       
       if(emass.ne.dnou(0))then
       
       b=dimag(zq(5))+dimag(zq(1))
       
       if(b.gt.eps(1))then
         
         a=b+dreal(zq(2))
         c=a+b-dreal(zq(1))
         r=dsqrt(a*b*c)
 
         
         zy(1)= emass*zq(4)/r
         zy(2)=-emass*b/r
         zy(3)=-zq(4)*a/r
         zy(4)=r/c
        
        else
        

         a=b+dreal(zq(2))
         
         zy(1)=-emass/dsqrt(a)
         zy(2)=dcmplx(dnou(0),dnou(0))
         zy(3)= dsqrt(a)
         zy(4)=dcmplx(dnou(0),dnou(0))
       
        endif

       else

       call lu(zy,zq)
       
       endif
       
       
       return
       
       
       entry ubminus(zy,zq)
       
       
       emass=dreal(zq(5))
       
       if(emass.ne.dnou(0))then
       
       b=dimag(zq(5))+dimag(zq(1))
       
       if(b.gt.eps(1))then
         
         a=b+dreal(zq(2))
         c=a+b-dreal(zq(1))
         r=dsqrt(a*b*c)

         zy(1)= zq(3)*a/r
         zy(2)=-r/c
         zy(3)=-emass*zq(3)/r
         zy(4)= emass*b/r
        
        else

         a=b+dreal(zq(2))
         
         zy(1)=-dsqrt(a)
         zy(2)=dcmplx(dnou(0),dnou(0))
         zy(3)= emass/dsqrt(a)
         zy(4)=dcmplx(dnou(0),dnou(0))
       
        endif

       else

       call lub(zy,zq)
       
       endif
      
       
       return
       
       entry vplus(zy,zq)
       
       
       emass=dreal(zq(5))
       
       if(emass.ne.dnou(0))then
       
       b=dimag(zq(5))+dimag(zq(1))
       
       if(b.gt.eps(1))then
         
         a=b+dreal(zq(2))
         c=a+b-dreal(zq(1))
         r=dsqrt(a*b*c)

         zy(1)=-emass*zq(4)/r 
         zy(2)= emass*b/r
         zy(3)=-zq(4)*a/r
         zy(4)= r/c
        
        else

         a=b+dreal(zq(2))
         
         zy(1)= emass/dsqrt(a)
         zy(2)=dcmplx(dnou(0),dnou(0))
         zy(3)= dsqrt(a)
         zy(4)=dcmplx(dnou(0),dnou(0))
       
        endif

       else

       call lu(zy,zq)
       
       endif
      
       return

       entry vbplus(zy,zq)
     
       emass=dreal(zq(5))
       
       if(emass.ne.dnou(0))then
       
       b=dimag(zq(5))+dimag(zq(1))
       
       if(b.gt.eps(1))then
         
         a=b+dreal(zq(2))
         c=a+b-dreal(zq(1))
         r=dsqrt(a*b*c)

         zy(1)= zq(3)*a/r 
         zy(2)=-r/c
         zy(3)= emass*zq(3)/r
         zy(4)=-emass*b/r
        
        else

         a=b+dreal(zq(2))
         
         zy(1)=-dsqrt(a)
         zy(2)=dcmplx(dnou(0),dnou(0))
         zy(3)=-emass/dsqrt(a)
         zy(4)=dcmplx(dnou(0),dnou(0))
       
        endif

       else

       call lub(zy,zq)
       
       endif
      
       return
       
       entry vminus(zy,zq)
       
       emass=dreal(zq(5))
       
       if(emass.ne.dnou(0))then
       
       b=dimag(zq(5))+dimag(zq(1))
       
       if(b.gt.eps(1))then
         
         a=b+dreal(zq(2))
         c=a+b-dreal(zq(1))
         r=dsqrt(a*b*c)

         zy(1)= r/c
         zy(2)= zq(3)*a/r
         zy(3)= emass*b/r
         zy(4)= emass*zq(3)/r
        
        else

         a=b+dreal(zq(2))
         
         zy(1)=dcmplx(dnou(0),dnou(0))
         zy(2)=-dsqrt(a)
         zy(3)=dcmplx(dnou(0),dnou(0))
         zy(4)=-emass/dsqrt(a)
       
        endif

       else

       call ru(zy,zq)
       
       endif
      
       return
       
       
       entry vbminus(zy,zq)
       
       emass=dreal(zq(5))
       
       if(emass.ne.dnou(0))then
       
       b=dimag(zq(5))+dimag(zq(1))
       
       if(b.gt.eps(1))then
         
         a=b+dreal(zq(2))
         c=a+b-dreal(zq(1))
         r=dsqrt(a*b*c)

         zy(1)=-emass*b/r
         zy(2)=-emass*zq(4)/r
         zy(3)=-r/c
         zy(4)=-zq(4)*a/r
        
        else

         a=b+dreal(zq(2))
         
         zy(1)=dcmplx(dnou(0),dnou(0))
         zy(2)= emass/dsqrt(a)
         zy(3)=dcmplx(dnou(0),dnou(0))
         zy(4)= dsqrt(a)
       
        endif
       
       else

       call rub(zy,zq)
       
       endif
      
       
       return
       end
       
       subroutine massless_spinors
       include 'declare.h'
       dimension zy(4),zq(5)
       
       return
       
       entry ru(zy,zq)

       zy(3)=dcmplx(dnou(0),dnou(0))
       zy(4)=dcmplx(dnou(0),dnou(0))
      
       pp=dreal(zq(1))
       
       if(pp.gt.eps(1))then
      
       a=dsqrt( pp )
       zy(2)= zq(3)/a
       zy(1)= a
       
       else
       
       zy(2)=dcmplx(-dsqrt(dreal(zq(2))),dnou(0))
       zy(1)=dcmplx(dnou(0),dnou(0))
       
       endif
       
       
       return
       
       entry lu(zy,zq)
        
       zy(1)=dcmplx(dnou(0),dnou(0))
       zy(2)=dcmplx(dnou(0),dnou(0))
       pp=dreal(zq(1))
       
       if(pp.gt.eps(1))then
      
       a=dsqrt( pp )
       zy(3)=-zq(4)/a
       zy(4)= a
      
       else
      
       zy(3)=dcmplx(dsqrt(dreal(zq(2))),dnou(0))
       zy(4)=dcmplx(dnou(0),dnou(0))
      
       endif
       
       
       return
     
       entry lub(zy,zq)
       

       zy(3)=dcmplx(dnou(0),dnou(0))
       zy(4)=dcmplx(dnou(0),dnou(0))
       pp=dreal(zq(1))
       
       if(pp.gt.eps(1))then
      
       a=dsqrt( pp )
       zy(1)= zq(3)/a
       zy(2)=-a
       
       else
       
       zy(1)=dcmplx(-dsqrt(dreal(zq(2))),dnou(0))
       zy(2)=dcmplx(dnou(0),dnou(0))

       endif
       
       
     
       
       return
        
       
       
       entry rub(zy,zq)
       
       

       zy(1)=dcmplx(dnou(0),dnou(0))
       zy(2)=dcmplx(dnou(0),dnou(0))
       pp=dreal(zq(1))
       
       if(pp.gt.eps(1))then
      
       a=dsqrt( pp )
       zy(4)=-zq(4)/a
       zy(3)=-a
      
       else
      
       zy(4)= dcmplx(dsqrt(dreal(zq(2))),dnou(0))
       zy(3)=dcmplx(dnou(0),dnou(0))
     
       endif
      
      
         
        
       return
       end
